Updated on Sep 23, 2026

Modern Javascript event calendar

Use it in responsive mobile & desktop web apps and wherever Javascript runs.

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The calendar view supports everything from single to multiple week views all the way to month grids with various ways to render events.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

Javascript Calendar Calendar for Javascript

Calendar - Mobile Month View

Change demo

Use the event calendar for mobile, desktop and everything in-between. The content perfectly fills the parent container or the mobile screen in full width. You can choose to render an agenda below the calendar broken up into days ordered chronologically. All of this is configured in the view option.

You can use the calendar and agenda together or separately. For more ways to use the agenda learn about how to configure it.

Interested to see how the event calendar looks on largers screens with labels?  Check out the next demo →
Copy code
View code on GitHub

Calendar - Desktop Month View

Change demo

Desktops or larger screens provide more space, which means you can use not just the horizontal but vertical space as well. Horizontally the calendar grows to fill the full width of the parent container while the height can be adjusted through the height option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Interested to see how the event calendar looks on smaller screens?  Check out the previous demo →
Copy code
View code on GitHub

Calendar - Responsive Month View

Change demo

The event calendar is fully responsive. It adapts to the available space and fills the screen to look good everywhere. While you don't have to worry about the width the height can be manually adjusted with the height option.

Use the responsive option to configure how the calendar behaves on different sized screens. The responsive option is equipped with five breakpoints - xsmall (up to 575px), small (up to 767px), medium (up to 991px), large (up to 1199px), xlarge (from 1200px). Custom breakpoints can be added if necessary: my-custom-breakpoint: { breakpoint: 600 } (from 600px up to the next breakpoint).

Change the viewport

Calendar - Printing & PDF Export

Change demo

The event calendar includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the calendar. In addition to that, you can call the print method on the instance which grabs only the markup of the calendar, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the calendar rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Calendar - Event Labels

Change demo

Events can be displayed in a couple of different ways. Most of the time showing the event data inside and across the calendar cells is the way to go. When configuring the calendar object, you can set labels: true. All of this happens under the view option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Rather show events in a pop-over?  Take a look at the next example →
Copy code
View code on GitHub

Calendar - With Event Popup

Change demo

Besides displaying events as labels, you can have them show up in a pop-over. Set it up through the calendar: {popover: true} object inside the view option. Using the popover setting saves vertical space and provides a subtle cue to the user that there are events. A small dot will appear in day cells with events or if calendar: {count: true} is set, an event count is displayed.

The same popover is rendered when events are displayed as labels and not all fit vertically in the calendar day cells.

Interested in customizing how the events look?  Take a look at how you can do it →
Copy code
View code on GitHub

Calendar - Property Booking Calendar

Change demo

When keeping records of bookings, the event calendar with exact label displays can come in handy. The labels accurately mark the exact start (e.g. 14:00) and end times (e.g. 11:00) of bookings, consolidating all booking records in a single, clear view.

By combining the eventDisplay: 'exact' setting under the view option with customizable renderCalendarEventContent , you can tailor the calendar to your specific needs. This allows you to create an efficient and user-friendly booking planning UI, ensuring all your bookings are easily managed and clearly displayed.

Copy code
View code on GitHub

Calendar - Custom Event Sort Order

Change demo

When rendering events, the default logic determines the order:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →
Copy code
View code on GitHub

Calendar - Timezone Configuration

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Calendar - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Copy code
View code on GitHub

Calendar - Event Search Popup

Change demo

Use the available real estate in the calendar header to add event search. With the templating capabilities of the header you can easily add a search box and use a separate agenda instance to show the search results. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in a sidebar next to the event calendar using a similar search box with an inline agenda instead of a dropdown.

Copy code
View code on GitHub

Calendar - Search Events

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header of the event calendar using a similar search box with an agenda listed in a popup instead of rendered inline.

Copy code
View code on GitHub

Calendar - Week and Month View

Change demo

The calendar view supports variable weeks. Save space by only displaying one or two weeks or go for a full month where it makes sense. Use the type and size properties of the view option to set the size of the month or week view.

You can also set the first day of the week using the firstDay option, where Sunday is 0, Monday is 1, etc.

Calendar - Quarter and Year View

Change demo

Besides the single month view, the calendar can be configured to render multiple months or a year. Controlled through the calendar.type and calendar.size properties of the view option.

Depending on the height of the parent container the calendar is rendered in, the header that can be used for navigation is sticky at the top while the months are vertically scrollable.

Copy code
View code on GitHub

Calendar - Show All or Limit Event Labels per Day

Change demo
Show All or Limit Event Labels per Day
Download and try example View code on GitHub

Labels on the event calendar go hand in hand with the height of the event calendar rows (representing weeks). It is possible to render as many labels as fit and keep the row heights equal. The row height is liquid and determined by the height of the calendar.

If you would like to render all labels, then passing labels: 'all' will do just that. This can make the row heights variable.

Alternatively a maximum number of labels can be set by passing a number to the labels property of the view.calendar option.

If there are more events than the number of labels for a particular day, an "x more" label will help users list out all events for the day.

By default the width of the labels fill the day cells (eventDisplay: 'fill') but alternatively eventDisplay: 'exact' can be used to display the labels with exact times.

Calendar - Colored Cell Backgrounds

Change demo

Color the background of the days with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events.

Use the onPageLoading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to color time ranges & days in the scheduler?  Learn how to do it →
Copy code
View code on GitHub

Calendar - Day, Week and Month Views

Change demo

Dynamically switch views within one calendar instance. Use a UI control to let users do the switching or do it programmatically. This example features a segmented component inside the header, but the live option changes can be invoked from anywhere.

Switch between a month view with a monthly agenda, a week view with a weekly agenda and daily event list.

Use the setOptions method to dynamically update any option.

Copy code
View code on GitHub

Calendar - Navigate from External Control

Change demo

This example demonstrates how can the Eventcalendar navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Calendar on the right. Changing date on the Datepicker will trigger the date change on the Calendar.

The Datepicker calls the navigate method of the Calendar in its onChange event, while the Calendar sets the datepicker value with the setVal method from its onSelectedDateChange event.

Copy code
View code on GitHub

Calendar - Event Display

Change demo

You can customize the look of the labels and show additional content besides the event.title. There are two approaches you can take:

  • Only customize the content of the labels - For this you will want to use the renderCalendarEventContent option. The color and positioning of the label will be handled by the calendar. The title and any other custom fields you want to show inside the label is your responsibility.
  • Fully customize how the labels look (like in this example) - Use the renderCalendarEvent option. All original event fields along with computed fields like isMultiDay, lastDay can be leveraged for constructing the render function. With the renderCalendarEvent you will have full control over how the labels are styled including things like color, title and any custom fields.
Copy code
View code on GitHub

Calendar - Event Popover

Change demo

The events listed in the popover can be customized in two ways:

  • Full event customization (like in this example) - The calendar handles the rendering of events in the correct order. Styling the content, colors and everything else is your responsibility.
  • Content customization - The calendar prints the start and end times, allDay and sets the appropriate color. Content like title and other fields can be shown.

You can provide styling to the title field and any other custom fields like description, location, participants ...

Pass a rendering function to the renderPopoverEventContent option. All original event fields along with computed fields like isMultiDay, lastDay are passed to the function. For a fully custom event rendering use the renderPopoverEvent option.

If you add custom markup you will want to add styling too. Use the popoverClass under the view option to tell the calendar what CSS class it should append to the popover container so that you can write specific CSS rules.

Copy code
View code on GitHub

Calendar - Custom Header

Change demo

You can customize how the header of the event calendar looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between calendar and scheduler.

Use the renderHeader option for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <div mbsc-calendar-nav></div>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <button mbsc-calendar-today></button>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <button mbsc-calendar-prev></button>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <button mbsc-calendar-next></button>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →
Copy code
View code on GitHub

Calendar - Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the onEventHoverIn and onEventHoverOut lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Copy code
View code on GitHub

Calendar - Add Event on Hover

Change demo

Hover-based interactions can be simple yet elegant. Using the onCellHoverIn and onCellHoverOut events, the calendar dynamically displays an "Add event" button when users hover over day cells, providing an intuitive way to create new events with minimal interface clutter.

For customizing the cell content appearance, the renderCalendarDayContent is the perfect candidate, as it holds the basic structure of the day cell.

Copy code
View code on GitHub

Calendar - Drag and Drop

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Calendar - Drag and Drop Permissions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true

To control this on an event basis, use the appropriate properties which have precedence over global calendar options.

Calendar - Drag and Drop Between Calendars

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two calendar instances can be enabled by turning on the externalDrag and externalDrop options.

Copy code
View code on GitHub

Calendar - Blocked Days and Date Ranges

Change demo

Entire days and ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific or recurring days you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Disable a specific range - { start: new Date(2020, 11, 19), end: new Date(2020, 11, 20) }

When dragging events onto disabled days, they will automatically be denied and onEventCreateFailed / onEventUpdateFailed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Calendar - Double Booking Prevention

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Calendar - Drag-and-Drop Task Presets

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is a car wrapping shop where different jobs need to be set up depending on the type of vehicle.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the calendar and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the onEventCreate lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a scheduler?  Check out this example →
Copy code
View code on GitHub

Calendar - External Drag and Drop from Lists

Change demo
External Drag and Drop from Lists
Download and try example View code on GitHub
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the event calendar with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the event calendar to receive external events by setting externalDrop

to true.

  • Initialize the external events (containers) as draggable components.

Set up a container as draggable with the mbsc-draggable attribute. Pass a skeleton event definition through the data-drag-data attribute as a stringified json object. This will be added to the event calendar on drop. If omitted, a default event will be created. For a more programmatic approach you might want to use the component initialization where the draggable is initialized in js code and the dragData can be passed as an object.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the event calendar. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the event calendar to receive external drops by setting externalDrop to true.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as onEventCreate, onEventCreated or onEventCreateFailed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the calendar and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the calendar to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer.

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the onEventDelete will be fired.

You can also use the onEventDragLeave and onEventDragEnter, and the drop container's onItemDragEnter and onItemDragLeave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the Third-party dragging support section in the documentation

Looking for external drag into a scheduler?  Check out this example →
Copy code
View code on GitHub

Calendar - Resource Filter in Header

Change demo

The calendar view doesn't have built in resource listing, however we can easily solve that inside the header using the segmented component. The header of the agenda is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <div mbsc-calendar-nav></div>. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <button mbsc-calendar-today></button>. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <button mbsc-calendar-prev></button>. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <button mbsc-calendar-next></button>. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →
Copy code
View code on GitHub

Calendar - Day Cell Summary View

Change demo

This demo showcases an advanced event calendar implementation with extensive day cell customization using the renderCalendarDay , which completely overrides the default cell rendering.

The calendar provides a comprehensive visual overview of scheduling density and workload management through custom aggregate data visualization with stress-level indicators, weather information, and color-coded backgrounds.

This approach prevents the calendar from rendering individual event labels, allowing full control over the cell content. Each day cell displays aggregate information calculated from the actual events, received by the custom template.

Users can navigate smoothly from the monthly or weekly overview to a detailed daily schedule by clicking on a day cell, which highlights the selected day and loads all events. A convenient back button allows a quick return to the previous view. Each cell also includes an add button for creating new appointments, and events can be added by dragging or clicking in the week or day view.

Copy code
View code on GitHub

Calendar - Event Data Structure

Change demo

The event data structure for the calendar is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs part of the resources array.
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that happens before the start of the event. This buffer area can help you visualise delays or added minutes for tasks. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • bufferAfter - Defines a buffer time in minutes that happens after the end of the event. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Calendar - Date Format Inputs

Change demo

Understanding how to work with dates inside the event calendar is essential. You can pass to the data, marked, colors and labels in four different formats. The event calendar can work with Javascript date objects, ISO strings and Moment.js objects.

Calendar - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Calendar - Inline Events

Change demo

What is an event calendar without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the event calendar.

Do you want to learn about the event data sctructure?  See how the event object is built →
Copy code
View code on GitHub

Calendar - Load Events from API

Change demo

The calendar can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the calendar understands.

Interested in load on demand?  Dynamically load events on month change →
Copy code
View code on GitHub

Calendar - Load Events on Demand

Change demo

The event calendar supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the onPageLoading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →
Copy code
View code on GitHub

Calendar - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Calendar - Outlook Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Calendar - Public Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.
Copy code
View code on GitHub

Calendar - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out the next example →
Copy code
View code on GitHub

Calendar - Recurring Events Editor

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Copy code
View code on GitHub

Calendar - Block Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate dates that are before today - this takes care of validating event drop and event creation on past dates
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the event calendar. Moving the past occurrences need to be handled in the

onEventUpdate and onEventCreate lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

onEventCreateFailed and onEventUpdateFailed lifecycle events

Copy code
View code on GitHub

Calendar - Bulk Actions — Edit, Delete & Update Events

Change demo
Bulk Actions — Edit, Delete & Update Events
Download and try example View code on GitHub

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Interested in moving events between two separate calendars?  Check out the next example for cut, copy, paste events →
Copy code
View code on GitHub

Calendar - Cut, Copy, Paste Events

Change demo

While copy & pasting one or more events is useful, sometimes being able to move events between two separate calendars can improve productivity. How the calendars are laid out depends on the application, but the basic idea is that you will need to be able to tell where the events from the clipboard will be pasted.

In this example this is implemented by tracking the active instance, which is determined by the active tab of the segmented control. With this out of the way, CTRL/CMD+C/X/Z/V handle the copy, cut, undo and paste actions.

Looking for multiple event selection & bulk operations?  Take a look at the previous example →
Copy code
View code on GitHub
mobiscroll.setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

var containerElm = document.getElementById('demo-copy-cut-paste-cont');
var firstContainer = document.getElementById('demo-copy-cut-paste-first-cont');
var secondContainer = document.getElementById('demo-copy-cut-paste-second-cont');
var dummyElm = document.getElementById('my-focus');
var selectedEvents = [];
var deletedEvents = [];
var cutEvents = [];
var pastedEvents = [];
var today = new Date();
var toDate;
var originDate;
var firstToDate = today;
var secondToDate = today;
var activeInst;
var originInst;
var cutInst;
var menuOpen;
var action;
var menuData = [
  { text: 'Copy', value: 'c' },
  { text: 'Cut', value: 'x' },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete' },
];
var disabledMenu = [
  { text: 'Copy', value: 'c', disabled: true },
  { text: 'Cut', value: 'x', disabled: true },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete', disabled: true },
];
var calendarSettings = {
  clickToCreate: true,
  dragToCreate: true,
  dragToMove: true,
  dragToResize: true,
  selectMultipleEvents: true,
  view: {
    calendar: {
      labels: 'all',
    },
  },
  onSelectedEventsChange: function (args, inst) {
    if (inst === secondInst) {
      secondInst.setSelectedEvents(args.events);
    } else {
      firstInst.setSelectedEvents(args.events);
    }
  },
  onPageLoading: function (args, inst) {
    if (inst === secondInst) {
      secondToDate = args.month;
    } else {
      firstToDate = args.month;
    }
    toDate = args.month;
  },
  onCellRightClick: function (args, inst) {
    if (!menuOpen) {
      args.domEvent.preventDefault();
      menu.setOptions({
        data: disabledMenu,
        anchor: args.domEvent.target,
      });
      setTimeout(function () {
        menu.open();
      });
      activeInst = inst;
    }
  },
  onEventRightClick: function (args, inst) {
    if (inst.getSelectedEvents().length <= 1) {
      inst.setSelectedEvents([args.event]);
    }
    args.domEvent.preventDefault();
    menu.setOptions({
      data: menuData,
      anchor: args.domEvent.target,
    });
    setTimeout(function () {
      menu.open();
    });
    activeInst = inst;
    menuOpen = true;
  },
  onEventDeleted: function (args, inst) {
    deletedEvents = args.events;
    originInst = inst;
    action = 'delete';
    mobiscroll.snackbar({
      button: {
        action: function () {
          inst.addEvent(deletedEvents);
          deletedEvents = [];
        },
        text: 'Undo',
      },
      duration: 3000,
      message: 'Event' + (deletedEvents.length === 1 ? '' : 's') + ' deleted',
    });
    dummyElm.focus();
  },
};
var firstInst = mobiscroll.eventcalendar(
  '#demo-copy-cut-paste-first',
  Object.assign(
    {
      data: [
        {
          start: '2026-10-02T09:00',
          end: '2026-10-06T18:00',
          title: 'Business of Software Conference',
          color: '#ff6d42',
        },
        {
          start: '2026-10-10T07:00',
          end: '2026-10-10T08:00',
          title: 'Green box to post office',
          color: '#6e7f29',
        },
        {
          start: '2026-10-15T09:30',
          end: '2026-10-15T10:30',
          title: 'Product team mtg.',
          color: '#f67944',
        },
        {
          start: '2026-10-23T11:00',
          end: '2026-10-23T11:45',
          title: 'Stakeholder mtg.',
          color: '#a144f6',
        },
        {
          start: '2026-10-28T13:00',
          end: '2026-10-28T13:45',
          title: "Lunch @ Butcher's",
          color: '#00aabb',
        },
      ],
    },
    calendarSettings,
  ),
);
var secondInst = mobiscroll.eventcalendar(
  '#demo-copy-cut-paste-second',
  Object.assign(
    {
      data: [
        {
          start: '2026-10-04T08:45',
          end: '2026-10-04T10:00',
          title: 'Quick mtg. with Martin',
          color: '#de3d83',
        },
        {
          start: '2026-10-08T15:00',
          end: '2026-10-08T16:00',
          title: 'General orientation',
          color: '#a71111',
        },
        {
          start: '2026-10-10T13:00',
          end: '2026-10-14T21:00',
          title: 'Friends binge marathon',
          color: '#7bde83',
        },
        {
          start: '2026-10-23T08:00',
          end: '2026-10-27T09:00',
          title: 'Product team mtg.',
          color: '#913aa7',
        },
      ],
    },
    calendarSettings,
  ),
);
var menu = mobiscroll.select('#copy-cut-paste-menu', {
  touchUi: false,
  display: 'anchored',
  buttons: [],
  data: menuData,
  inputElement: document.getElementById('copy-cut-paste-menu-input'),
  onChange: function (args) {
    detectAction(args.value);
  },
  onClose: function () {
    menuOpen = false;
    // Clear selection
    menu.setVal();
  },
});

function monthDiff(d1, d2) {
  return d2.getMonth() - d1.getMonth() + 12 * (d2.getFullYear() - d1.getFullYear());
}

function pasteEvents() {
  var evLength = selectedEvents.length;
  if (evLength > 0) {
    for (var i = 0; i < evLength; ++i) {
      var event = Object.assign({}, selectedEvents[i]);
      var startDate = new Date(event.start);
      var endDate = new Date(event.end);
      var diff = Math.abs(endDate - startDate);

      event.start = startDate.setMonth(startDate.getMonth() - monthDiff(toDate, originDate));
      event.end = new Date(startDate.getTime() + diff);

      delete event.id;
      activeInst.addEvent(event);
      pastedEvents.push(event);
    }
    if (action === 'cut') {
      cutEvents = selectedEvents;
      cutInst = activeInst;
      originInst.removeEvent(selectedEvents);
      mobiscroll.snackbar({
        button: {
          action: function () {
            originInst.addEvent(cutEvents);
            cutInst.removeEvent(pastedEvents);
            mobiscroll.toast({
              message: 'Event' + (cutEvents.length === 1 ? '' : 's') + ' reverted',
            });
          },
          text: 'Undo',
        },
        duration: 3000,
        message: 'Event' + (selectedEvents.length === 1 ? '' : 's') + ' pasted',
      });
    } else {
      mobiscroll.toast({
        message: 'Event' + (evLength === 1 ? '' : 's') + ' pasted',
      });
    }
    dummyElm.focus();
    if (action !== 'copy') {
      selectedEvents = [];
    }
  }
}

function detectAction(key) {
  switch (key) {
    case 'delete': // Delete
      action = 'delete';
      originInst = activeInst;
      var selEvs = activeInst.getSelectedEvents();
      if (selEvs.length > 0) {
        activeInst.removeEvent(selEvs);
        deletedEvents = selEvs;
        mobiscroll.snackbar({
          button: {
            action: function () {
              activeInst.addEvent(selEvs);
              deletedEvents = [];
            },
            text: 'Undo',
          },
          duration: 3000,
          message: 'Event' + (selEvs.length === 1 ? '' : 's') + ' deleted',
        });
        dummyElm.focus();
      }
      break;
    case 'c': // Copy
      if (activeInst.getSelectedEvents().length > 0) {
        action = 'copy';
        selectedEvents = activeInst.getSelectedEvents();
        if (selectedEvents.length > 0) {
          originInst = activeInst;
          originDate = toDate;
          mobiscroll.toast({
            message: 'Event' + (selectedEvents.length === 1 ? '' : 's') + ' copied',
          });
        }
      }
      break;
    case 'x': // Cut
      if (activeInst.getSelectedEvents().length > 0) {
        action = 'cut';
        selectedEvents = activeInst.getSelectedEvents();
        if (selectedEvents.length > 0) {
          originInst = activeInst;
          deletedEvents = [];
          originDate = toDate;
          mobiscroll.toast({
            message: 'Event' + (selectedEvents.length === 1 ? '' : 's') + ' cut',
          });
        }
      }
      break;
    case 'z': // Undo
      if (action === 'delete') {
        originInst.addEvent(deletedEvents);
        deletedEvents = [];
      } else if (action === 'cut') {
        originInst.addEvent(cutEvents);
        cutInst.removeEvent(pastedEvents);
        cutEvents = [];
        pastedEvents = [];
      }
      break;
    case 'v': // Paste
      pasteEvents();
      break;
  }
}

document.querySelectorAll('.md-header-toggle').forEach(function (elm) {
  elm.addEventListener('change', function (ev) {
    if (ev.target.value === 'first') {
      firstContainer.classList.remove('md-hide-calendar');
      secondContainer.classList.add('md-hide-calendar');
      activeInst = firstInst;
      toDate = firstToDate;
      secondInst.setSelectedEvents([]);
    } else {
      secondContainer.classList.remove('md-hide-calendar');
      firstContainer.classList.add('md-hide-calendar');
      activeInst = secondInst;
      toDate = secondToDate;
      firstInst.setSelectedEvents([]);
    }
  });
});

containerElm.addEventListener('keydown', function (ev) {
  if (ev.ctrlKey || ev.metaKey) {
    detectAction(ev.key);
  }
  if (ev.key === 'Delete') {
    detectAction('delete');
  }
});

secondContainer.classList.add('md-hide-calendar');
activeInst = firstInst;
  
<div mbsc-page id="demo-copy-cut-paste-cont">
    <div class="mbsc-flex-col md-copy-cut-paste">
        <div class="mbsc-flex-none">
            <label>
                First calendar
                <input type="radio" mbsc-segmented name="header-toggle" class="md-header-toggle" value="first" checked />
            </label>
            <label>
                Second calendar
                <input type="radio" mbsc-segmented name="header-toggle" class="md-header-toggle" value="second" />
            </label>
        </div>
        <div class="mbsc-flex-col mbsc-flex-1-1">
            <div id="demo-copy-cut-paste-first-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
                <div id="demo-copy-cut-paste-first"></div>
            </div>
            <div id="demo-copy-cut-paste-second-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
                <div id="demo-copy-cut-paste-second"></div>
            </div>
            <input id="copy-cut-paste-menu" type="hidden" />
        </div>
    </div>
    <div id="my-focus" tabindex="-1"></div>
</div>
  
.md-copy-cut-paste .mbsc-segmented {
    width: 300px;
    margin-left: auto;
    margin-right: auto;
}

.md-copy-cut-paste .md-hide-calendar {
    visibility: hidden;
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
}
  
Move events between two event calendars using cut, copy, paste, and undo — switch calendars.

Calendar - Themes and Dark Mode

Change demo

The look and feel of the event calendar can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Calendar - Localization

Change demo

The components are fully localized. In case of the event calendar this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →
Copy code
View code on GitHub

Calendar - Gregorian, Jalali & Hijri

Change demo

The event calendar supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Calendar - Event Hooks

Change demo

The event calendar ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like onEventClick, onInit, onSelectedDateChange ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Updated on Sep 23, 2026

Modern Vue event calendar

Use it in responsive mobile & desktop web apps and Ionic Vue projects

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The calendar view supports everything from single to multiple week views all the way to month grids with various ways to render events.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

Vue Calendar Calendar for Vue JS

Calendar - Mobile Month View

Change demo

Use the event calendar for mobile, desktop and everything in-between. The content perfectly fills the parent container or the mobile screen in full width. You can choose to render an agenda below the calendar broken up into days ordered chronologically. All of this is configured in the view option.

You can use the calendar and agenda together or separately. For more ways to use the agenda learn about how to configure it.

Interested to see how the event calendar looks on largers screens with labels?  Check out the next demo →

Calendar - Desktop Month View

Change demo

Desktops or larger screens provide more space, which means you can use not just the horizontal but vertical space as well. Horizontally the calendar grows to fill the full width of the parent container while the height can be adjusted through the height option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Interested to see how the event calendar looks on smaller screens?  Check out the previous demo →

Calendar - Responsive Month View

Change demo

The event calendar is fully responsive. It adapts to the available space and fills the screen to look good everywhere. While you don't have to worry about the width the height can be manually adjusted with the height option.

Use the responsive option to configure how the calendar behaves on different sized screens. The responsive option is equipped with five breakpoints - xsmall (up to 575px), small (up to 767px), medium (up to 991px), large (up to 1199px), xlarge (from 1200px). Custom breakpoints can be added if necessary: my-custom-breakpoint: { breakpoint: 600 } (from 600px up to the next breakpoint).

Change the viewport

Calendar - Printing & PDF Export

Change demo

The event calendar includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the calendar. In addition to that, you can call the print method on the instance which grabs only the markup of the calendar, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the calendar rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Calendar - Event Labels

Change demo

Events can be displayed in a couple of different ways. Most of the time showing the event data inside and across the calendar cells is the way to go. When configuring the calendar object, you can set labels: true. All of this happens under the view option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Rather show events in a pop-over?  Take a look at the next example →

Calendar - With Event Popup

Change demo

Besides displaying events as labels, you can have them show up in a pop-over. Set it up through the calendar: {popover: true} object inside the view option. Using the popover setting saves vertical space and provides a subtle cue to the user that there are events. A small dot will appear in day cells with events or if calendar: {count: true} is set, an event count is displayed.

The same popover is rendered when events are displayed as labels and not all fit vertically in the calendar day cells.

Interested in customizing how the events look?  Take a look at how you can do it →

Calendar - Property Booking Calendar

Change demo

When keeping records of bookings, the event calendar with exact label displays can come in handy. The labels accurately mark the exact start (e.g. 14:00) and end times (e.g. 11:00) of bookings, consolidating all booking records in a single, clear view.

By combining the eventDisplay: 'exact' setting under the view option with customizable calendarEventContent , you can tailor the calendar to your specific needs. This allows you to create an efficient and user-friendly booking planning UI, ensuring all your bookings are easily managed and clearly displayed.

Calendar - Custom Event Sort Order

Change demo

When rendering events, the default logic determines the order:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →

Calendar - Timezone Configuration

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Calendar - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Calendar - Event Search Popup

Change demo

Use the available real estate in the calendar header to add event search. With the templating capabilities of the header you can easily add a search box and use a separate agenda instance to show the search results. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in a sidebar next to the event calendar using a similar search box with an inline agenda instead of a dropdown.

Calendar - Search Events

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header of the event calendar using a similar search box with an agenda listed in a popup instead of rendered inline.

Calendar - Week and Month View

Change demo

The calendar view supports variable weeks. Save space by only displaying one or two weeks or go for a full month where it makes sense. Use the type and size properties of the view option to set the size of the month or week view.

You can also set the first day of the week using the firstDay option, where Sunday is 0, Monday is 1, etc.

Calendar - Quarter and Year View

Change demo

Besides the single month view, the calendar can be configured to render multiple months or a year. Controlled through the calendar.type and calendar.size properties of the view option.

Depending on the height of the parent container the calendar is rendered in, the header that can be used for navigation is sticky at the top while the months are vertically scrollable.

Calendar - Show All or Limit Event Labels per Day

Change demo

Labels on the event calendar go hand in hand with the height of the event calendar rows (representing weeks). It is possible to render as many labels as fit and keep the row heights equal. The row height is liquid and determined by the height of the calendar.

If you would like to render all labels, then passing labels: 'all' will do just that. This can make the row heights variable.

Alternatively a maximum number of labels can be set by passing a number to the labels property of the view.calendar option.

If there are more events than the number of labels for a particular day, an "x more" label will help users list out all events for the day.

By default the width of the labels fill the day cells (eventDisplay: 'fill') but alternatively eventDisplay: 'exact' can be used to display the labels with exact times.

Calendar - Colored Cell Backgrounds

Change demo

Color the background of the days with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events.

Use the page-loading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to color time ranges & days in the scheduler?  Learn how to do it →

Calendar - Day, Week and Month Views

Change demo

Dynamically switch views within one calendar instance. Use a UI control to let users do the switching or do it programmatically. This example features a segmented component inside the header, but the live option changes can be invoked from anywhere.

Switch between a month view with a monthly agenda, a week view with a weekly agenda and daily event list.

Thanks to property binding and all option changes are live and propagate accordingly.

Calendar - Navigate from External Control

Change demo

This example demonstrates how can the Eventcalendar navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Calendar on the right. Changing date on the Datepicker will trigger the date change on the Calendar.

The Datepicker updates the selectedDate option of the Calendar in its @change event, while the Calendar updates the datepicker value from its @selected-date-change event.

Calendar - Event Display

Change demo

You can customize the look of the labels and show additional content besides the event.title. There are two approaches you can take:

  • Only customize the content of the labels - For this you will want to use the calendarEventContent template. The color and positioning of the label will be handled by the calendar. The title and any other custom fields you want to show in the template is your responsibility.
  • Fully customize how the labels look (like in this example) - Use the calendarEvent template. All original event fields along with computed fields like isMultiDay, lastDay can be leveraged for constructing the template. With the calendarEvent template you will have full control over how the labels are styled including things like color, title and any custom fields.

Calendar - Event Popover

Change demo

The events listed in the popover can be customized in two ways:

  • Full event customization (like in this example) - The calendar handles the rendering of events in the correct order. Styling the content, colors and everything else is your responsibility.
  • Content customization - The calendar prints the start and end times, allDay and sets the appropriate color. Content like title and other fields can be shown.

You can provide styling to the title field and any other custom fields like description, location, participants ...

Create an event content template and pass it to the popoverEventContent template. All original event fields along with computed fields like isMultiDay, lastDay are passed to the template. For a fully custom event rendering use the popoverEvent template.

If you add custom markup you will want to add styling too. Use the popoverClass under the view option to tell the calendar what CSS class it should append to the popover container so that you can write specific CSS rules.

Calendar - Custom Header

Change demo

You can customize how the header of the event calendar looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between calendar and scheduler.

Use the header template for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <MbscCalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <MbscCalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <MbscCalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <MbscCalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the header template. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →

Calendar - Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the event-hover-in and event-hover-out lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Calendar - Add Event on Hover

Change demo

Hover-based interactions can be simple yet elegant. Using the cell-hover-in and cell-hover-out events, the calendar dynamically displays an "Add event" button when users hover over day cells, providing an intuitive way to create new events with minimal interface clutter.

For customizing the cell content appearance, the calendarDayContent is the perfect candidate, as it holds the basic structure of the day cell.

Calendar - Drag and Drop

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Calendar - Drag and Drop Permissions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true

To control this on an event basis, use the appropriate properties which have precedence over global calendar options.

Calendar - Drag and Drop Between Calendars

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two calendar instances can be enabled by turning on the externalDrag and externalDrop options.

Calendar - Blocked Days and Date Ranges

Change demo

Entire days and ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific or recurring days you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Disable a specific range - { start: new Date(2020, 11, 19), end: new Date(2020, 11, 20) }

When dragging events onto disabled days, they will automatically be denied and event-update-failed / event-create-failed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Calendar - Double Booking Prevention

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Calendar - Drag-and-Drop Task Presets

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is a car wrapping shop where different jobs need to be set up depending on the type of vehicle.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the calendar and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the event-create lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the event-create-failed event will be triggered.

Want to see how external presets look & feel for a scheduler?  Check out this example →

Calendar - External Drag and Drop from Lists

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the event calendar with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the event calendar to receive external events by setting externalDrop

to true.

  • Initialize the external events (containers) as draggable components.

Use the MbscDraggable component to specify a skeleton event through its dragData option and reference the draggable container in the element option. The dragData accepts a full event definition that will be added to the event calendar on drop. If omitted, a default event will be created.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the event calendar. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the event calendar to receive external drops by setting externalDrop to true.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as event-create, event-created or event-create-failed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the calendar and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the calendar to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the event-delete will be fired.

You can also use the event-drag-leave and event-drag-enter, and the drop container's item-drag-enter and item-drag-leave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the Third-party dragging support section in the documentation

Looking for external drag into a scheduler?  Check out this example →

Calendar - Resource Filter in Header

Change demo

The calendar view doesn't have built in resource listing, however we can easily solve that inside the header using the segmented component. The header of the agenda is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

For changing the order the controls are laid out, you only need to set up the header template.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →

Calendar - Day Cell Summary View

Change demo

This demo showcases an advanced event calendar implementation with extensive day cell customization using the calendarDay , which completely overrides the default cell rendering.

The calendar provides a comprehensive visual overview of scheduling density and workload management through custom aggregate data visualization with stress-level indicators, weather information, and color-coded backgrounds.

This approach prevents the calendar from rendering individual event labels, allowing full control over the cell content. Each day cell displays aggregate information calculated from the actual events, received by the custom template.

Users can navigate smoothly from the monthly or weekly overview to a detailed daily schedule by clicking on a day cell, which highlights the selected day and loads all events. A convenient back button allows a quick return to the previous view. Each cell also includes an add button for creating new appointments, and events can be added by dragging or clicking in the week or day view.

Calendar - Event Data Structure

Change demo

The event data structure for the calendar is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs part of the resources array.
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that happens before the start of the event. This buffer area can help you visualise delays or added minutes for tasks. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • bufferAfter - Defines a buffer time in minutes that happens after the end of the event. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Calendar - Date Format Inputs

Change demo

Understanding how to work with dates inside the event calendar is essential. You can pass to the data, marked, colors and labels in four different formats. The event calendar can work with Javascript date objects, ISO strings and Moment.js objects.

Calendar - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Calendar - Inline Events

Change demo

What is an event calendar without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the event calendar.

Do you want to learn about the event data sctructure?  See how the event object is built →

Calendar - Load Events from API

Change demo

The calendar can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the calendar understands.

Interested in load on demand?  Dynamically load events on month change →

Calendar - Load Events on Demand

Change demo

The event calendar supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the page-loading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →

Calendar - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Outlook Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Public Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out the next example →

Calendar - Recurring Events Editor

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Calendar - Block Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate dates that are before today - this takes care of validating event drop and event creation on past dates
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the event calendar. Moving the past occurrences need to be handled in the

event-update and event-create lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

event-update-failed and event-create-failed lifecycle events

Calendar - Bulk Actions — Edit, Delete & Update Events

Change demo
Bulk Actions — Edit, Delete & Update Events
Get started with this example

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Interested in moving events between two separate calendars?  Check out the next example for cut, copy, paste events →

Calendar - Cut, Copy, Paste Events

Change demo

While copy & pasting one or more events is useful, sometimes being able to move events between two separate calendars can improve productivity. How the calendars are laid out depends on the application, but the basic idea is that you will need to be able to tell where the events from the clipboard will be pasted.

In this example this is implemented by tracking the active instance, which is determined by the active tab of the segmented control. With this out of the way, CTRL/CMD+C/X/Z/V handle the copy, cut, undo and paste actions.

Looking for multiple event selection & bulk operations?  Take a look at the previous example →
Copy code
<script setup>
import {
  MbscEventcalendar,
  MbscPage,
  MbscSegmented,
  MbscSegmentedGroup,
  MbscSelect,
  MbscSnackbar,
  MbscToast,
  setOptions 
} from '@mobiscroll/vue'
import { ref } from 'vue'

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
})

const today = new Date()

const defaultMenuData = [
  { text: 'Copy', value: 'c' },
  { text: 'Cut', value: 'x' },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete' }
]

const disabledMenu = [
  { text: 'Copy', value: 'c', disabled: true },
  { text: 'Cut', value: 'x', disabled: true },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete', disabled: true }
]

const firstEvents = ref([
  {
    start: '2026-10-02T09:00',
    end: '2026-10-06T18:00',
    title: 'Business of Software Conference',
    color: '#ff6d42'
  },
  {
    start: '2026-10-10T07:00',
    end: '2026-10-10T08:00',
    title: 'Green box to post office',
    color: '#6e7f29'
  },
  {
    start: '2026-10-15T09:30',
    end: '2026-10-15T10:30',
    title: 'Product team mtg.',
    color: '#f67944'
  },
  {
    start: '2026-10-23T11:00',
    end: '2026-10-23T11:45',
    title: 'Stakeholder mtg.',
    color: '#a144f6'
  },
  {
    start: '2026-10-28T13:00',
    end: '2026-10-28T13:45',
    title: "Lunch @ Butcher's",
    color: '#00aabb'
  }
])

const secondEvents = ref([
  {
    start: '2026-10-04T08:45',
    end: '2026-10-04T10:00',
    title: 'Quick mtg. with Martin',
    color: '#de3d83'
  },
  {
    start: '2026-10-08T15:00',
    end: '2026-10-08T16:00',
    title: 'General orientation',
    color: '#a71111'
  },
  {
    start: '2026-10-10T13:00',
    end: '2026-10-14T21:00',
    title: 'Friends binge marathon',
    color: '#7bde83'
  },
  {
    start: '2026-10-23T08:00',
    end: '2026-10-27T09:00',
    title: 'Product team mtg.',
    color: '#913aa7'
  }
])

const myView = {
  calendar: { labels: 'all' }
}
const menuData = ref(defaultMenuData)
const selectValue = ref('')
const menuAnchor = ref(null)
const activeCalendar = ref('first')
const cutCalendar = ref('first')
const toDate = ref(today)
const firstToDate = ref(today)
const secondToDate = ref(today)
const originDate = ref(today)
const isMenuOpen = ref(false)
const selectedEvents = ref([])
const moveEvents = ref([])
const pastedEvents = ref([])
const deletedEvents = ref([])
const action = ref('')
const snackbarMessage = ref('')
const snackbarButton = ref(null)
const isSnackbarOpen = ref(false)
const toastMessage = ref(null)
const isToastOpen = ref(false)
const dummyElm = ref(null)
const menuElm = ref(null)
const firstSelectedEvents = ref([])
const secondSelectedEvents = ref([])

function monthDiff(d1, d2) {
  return d2.getMonth() - d1.getMonth() + 12 * (d2.getFullYear() - d1.getFullYear())
}

function pasteEvents() {
  const activeEvents = getActiveEvents()
  const activeSelectedEvents = selectedEvents.value
  let eventsToUpdate = [...activeEvents]
  if (activeSelectedEvents.length > 0) {
    for (const event of activeSelectedEvents) {
      const newEvent = Object.assign({}, event)
      const startDate = new Date(event.start)
      const endDate = new Date(event.end)
      const diff = Math.abs(endDate - startDate)

      startDate.setMonth(startDate.getMonth() - monthDiff(toDate.value, originDate.value))

      newEvent.start = startDate
      newEvent.end = new Date(startDate.getTime() + diff)

      delete newEvent.id

      eventsToUpdate = [...eventsToUpdate, newEvent]

      pastedEvents.value = [...pastedEvents.value, newEvent]
    }

    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }

    if (action.value === 'cut') {
      let cutEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
      moveEvents.value = [...selectedEvents.value]
      for (const event of selectedEvents.value) {
        cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
      }
      if (cutCalendar.value === 'first') {
        firstEvents.value = cutEvs
      } else {
        secondEvents.value = cutEvs
      }

      snackbarButton.value = {
        action: () => {
          let revertEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
          for (const event of moveEvents.value) {
            revertEvs = [...revertEvs, event]
          }
          if (cutCalendar.value === 'first') {
            firstEvents.value = revertEvs
          } else {
            secondEvents.value = revertEvs
          }

          let cutEvs = getActiveEvents()
          for (const event of pastedEvents.value) {
            cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
          }
          if (activeCalendar.value === 'first') {
            firstEvents.value = cutEvs
          } else {
            secondEvents.value = cutEvs
          }

          toastMessage.value =
            'Event' + (selectedEvents.value.length === 1 ? '' : 's') + ' reverted'
          isToastOpen.value = true
        },
        text: 'Undo'
      }
      snackbarMessage.value = 'Event' + (selectedEvents.value.length === 1 ? '' : 's') + ' pasted'
      dummyElm.value.focus()
      isSnackbarOpen.value = true
    } else {
      toastMessage.value = 'Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' pasted'
      isToastOpen.value = true
    }
    if (action.value !== 'copy') {
      selectedEvents.value = []
    }
  }
}

function getActiveEvents() {
  return activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
}

function getActiveSelectedEvents() {
  return activeCalendar.value === 'first' ? firstSelectedEvents.value : secondSelectedEvents.value
}

function deleteEvents() {
  const activeEvents = getActiveEvents()
  let eventsToUpdate = [...activeEvents]
  action.value = 'delete'
  const activeSelectedEvents = getActiveSelectedEvents()

  if (activeSelectedEvents.length > 0) {
    deletedEvents.value = activeSelectedEvents

    for (const event of activeSelectedEvents) {
      eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id)
    }

    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }

    snackbarButton.value = {
      action: () => {
        for (const event of activeSelectedEvents) {
          eventsToUpdate = [...eventsToUpdate, event]
        }
        if (activeCalendar.value === 'first') {
          firstEvents.value = eventsToUpdate
        } else {
          secondEvents.value = eventsToUpdate
        }
        deletedEvents.value = []
      },
      text: 'Undo'
    }
    snackbarMessage.value = 'Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' deleted'
    dummyElm.value.focus()
    isSnackbarOpen.value = true
  }
}

function activateAction(type) {
  if (selectedEvents.value.length > 0) {
    const act = type == 'copy' ? ' copied' : ' cut'
    originDate.value = toDate.value
    toastMessage.value = 'Event' + (selectedEvents.value.length === 1 ? '' : 's') + act
    isToastOpen.value = true
  }
}

function copyEvents() {
  if (activeCalendar.value === 'first') {
    if (firstSelectedEvents.value.length > 0) {
      action.value = 'copy'
      selectedEvents.value = firstSelectedEvents.value
      activateAction('copy')
    }
  } else {
    if (secondSelectedEvents.value.length > 0) {
      action.value = 'copy'
      selectedEvents.value = secondSelectedEvents.value
      activateAction('copy')
    }
  }
}

function cutEvents() {
  if (activeCalendar.value === 'first') {
    if (firstSelectedEvents.value.length > 0) {
      action.value = 'cut'
      selectedEvents.value = firstSelectedEvents.value
      cutCalendar.value = activeCalendar.value
      activateAction('cut')
      deletedEvents.value = []
    }
  } else {
    if (secondSelectedEvents.value.length > 0) {
      action.value = 'cut'
      selectedEvents.value = secondSelectedEvents.value
      cutCalendar.value = activeCalendar.value
      activateAction('cut')
      deletedEvents.value = []
    }
  }
}

function undoEvents() {
  const activeEvents = getActiveEvents()
  let eventsToUpdate = [...activeEvents]
  if (action.value === 'delete') {
    for (const event of deletedEvents.value) {
      eventsToUpdate = [...eventsToUpdate, event]
    }
    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }
    deletedEvents.value = []
  } else if (action.value === 'cut') {
    let revertEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
    for (const event of moveEvents.value) {
      revertEvs = [...revertEvs, event]
    }
    if (cutCalendar.value === 'first') {
      firstEvents.value = revertEvs
    } else {
      secondEvents.value = revertEvs
    }

    let cutEvs = getActiveEvents()
    for (const event of pastedEvents.value) {
      cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
    }
    if (activeCalendar.value === 'first') {
      firstEvents.value = cutEvs
    } else {
      secondEvents.value = cutEvs
    }

    pastedEvents.value = []
  }
}

function detectAction(key) {
  switch (key) {
    case 'delete': // Delete
      deleteEvents()
      break
    case 'c': // Copy
      copyEvents()
      break
    case 'x': // Cut
      cutEvents()
      break
    case 'z': // Undo
      undoEvents()
      break
    case 'v': // Paste
      pasteEvents()
      break
  }
}

function switchCalendar(ev) {
  if (ev.target.value === 'first') {
    toDate.value = firstToDate.value
    secondSelectedEvents.value = []
  } else {
    toDate.value = secondToDate.value
    firstSelectedEvents.value = []
  }
}

function handlePageLoading(args) {
  if (activeCalendar.value === 'first') {
    firstToDate.value = args.month
  } else {
    secondToDate.value = args.month
  }
  toDate.value = args.month
}

function handleCellRightClick(args) {
  if (!isMenuOpen.value) {
    args.domEvent.preventDefault()
    menuData.value = disabledMenu
    menuAnchor.value = args.domEvent.target
    isMenuOpen.value = true
  }
}

function handleEventRightClick(args) {
  const activeEvents = activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
  if (activeEvents.length <= 1) {
    if (activeCalendar.value === 'first') {
      firstEvents.value = [args.event]
    } else {
      secondEvents.value = [args.event]
    }
  }
  args.domEvent.preventDefault()
  menuData.value = defaultMenuData
  menuAnchor.value = args.domEvent.target
  isMenuOpen.value = true
}

function handleEventDeleted(args) {
  deletedEvents.value = args.events
  action.value = 'delete'
  snackbarButton.value = {
    action: () => {
      const activeEvents = activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
      let eventsToUpdate = [...activeEvents]
      for (const event of deletedEvents.value) {
        eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id)
      }

      if (activeCalendar.value === 'first') {
        firstEvents.value = eventsToUpdate
      } else {
        secondEvents.value = eventsToUpdate
      }

      deletedEvents.value = []
    },
    text: 'Undo'
  }
  snackbarMessage.value = 'Event' + (deletedEvents.value.length === 1 ? '' : 's') + ' deleted'
  dummyElm.value.focus()
  isSnackbarOpen.value = true
}

function handleFirstSelectedEventsChange(args) {
  firstSelectedEvents.value = args.events
}

function handleSecondSelectedEventsChange(args) {
  secondSelectedEvents.value = args.events
}

function handleSelectChange(args) {
  detectAction(args.value)
}

function handleSelectClose() {
  isMenuOpen.value = false
  selectValue.value = null
}

function handleKeyDown(ev) {
  if (ev.ctrlKey || ev.metaKey) {
    detectAction(ev.key)
  }
  if (ev.key === 'Delete') {
    detectAction('delete')
  }
}
</script>

<template>
  <MbscPage @keydown="handleKeyDown($event)">
    <div class="mbsc-flex-col md-copy-cut-paste">
      <div class="mbsc-flex-none">
        <MbscSegmentedGroup v-model="activeCalendar" @change="switchCalendar($event)">
          <MbscSegmented value="first">First calendar</MbscSegmented>
          <MbscSegmented value="second">Second calendar</MbscSegmented>
        </MbscSegmentedGroup>
      </div>
      <div class="mbsc-flex-col mbsc-flex-1-1">
        <div id="demo-copy-cut-paste-first-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="firstEvents"
            :selectedEvents="firstSelectedEvents"
            :className="activeCalendar === 'second' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleFirstSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <div id="demo-copy-cut-paste-second-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="secondEvents"
            :selectedEvents="secondSelectedEvents"
            :className="activeCalendar === 'first' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleSecondSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <MbscSelect
          ref="menuElm"
          display="anchored"
          v-model="selectValue"
          :touchUi="false"
          :data="menuData"
          :anchor="menuAnchor"
          :buttons="[]"
          :isOpen="isMenuOpen"
          :inputProps="{ type: 'hidden' }"
          @change="handleSelectChange"
          @close="handleSelectClose"
        />
      </div>
    </div>
    <div ref="dummyElm" tabindex="-1"></div>
    <MbscSnackbar
      :message="snackbarMessage"
      :button="snackbarButton"
      :duration="3000"
      :isOpen="isSnackbarOpen"
      @close="isSnackbarOpen = false"
    />
    <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="isToastOpen = false" />
  </MbscPage>
</template>

<style>
.md-copy-cut-paste .mbsc-segmented {
  width: 300px;
  margin-left: auto;
  margin-right: auto;
}

.md-copy-cut-paste .md-hide-calendar {
  visibility: hidden;
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}
</style>
  <MbscPage @keydown="handleKeyDown($event)">
    <div class="mbsc-flex-col md-copy-cut-paste">
      <div class="mbsc-flex-none">
        <MbscSegmentedGroup v-model="activeCalendar" @change="switchCalendar($event)">
          <MbscSegmented value="first">First calendar</MbscSegmented>
          <MbscSegmented value="second">Second calendar</MbscSegmented>
        </MbscSegmentedGroup>
      </div>
      <div class="mbsc-flex-col mbsc-flex-1-1">
        <div id="demo-copy-cut-paste-first-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="firstEvents"
            :selectedEvents="firstSelectedEvents"
            :className="activeCalendar === 'second' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleFirstSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <div id="demo-copy-cut-paste-second-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="secondEvents"
            :selectedEvents="secondSelectedEvents"
            :className="activeCalendar === 'first' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleSecondSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <MbscSelect
          ref="menuElm"
          display="anchored"
          v-model="selectValue"
          :touchUi="false"
          :data="menuData"
          :anchor="menuAnchor"
          :buttons="[]"
          :isOpen="isMenuOpen"
          :inputProps="{ type: 'hidden' }"
          @change="handleSelectChange"
          @close="handleSelectClose"
        />
      </div>
    </div>
    <div ref="dummyElm" tabindex="-1"></div>
    <MbscSnackbar
      :message="snackbarMessage"
      :button="snackbarButton"
      :duration="3000"
      :isOpen="isSnackbarOpen"
      @close="isSnackbarOpen = false"
    />
    <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="isToastOpen = false" />
  </MbscPage>
<script setup lang="ts">
import {
  MbscEventcalendar,
  MbscPage,
  MbscSegmented,
  MbscSegmentedGroup,
  MbscSelect,
  MbscSnackbar,
  MbscToast,
  setOptions 
} from '@mobiscroll/vue'
import type {
  MbscCalendarEvent,
  MbscCellClickEvent,
  MbscEventcalendarView,
  MbscEventClickEvent,
  MbscEventDeletedEvent,
  MbscPageLoadingEvent,
  MbscSelectedEventsChangeEvent
} from '@mobiscroll/vue'
import { ref } from 'vue'

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
})

const today: Date = new Date()

const defaultMenuData = [
  { text: 'Copy', value: 'c' },
  { text: 'Cut', value: 'x' },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete' }
]

const disabledMenu = [
  { text: 'Copy', value: 'c', disabled: true },
  { text: 'Cut', value: 'x', disabled: true },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete', disabled: true }
]

const firstEvents = ref<MbscCalendarEvent[]>([
  {
    start: '2026-10-02T09:00',
    end: '2026-10-06T18:00',
    title: 'Business of Software Conference',
    color: '#ff6d42'
  },
  {
    start: '2026-10-10T07:00',
    end: '2026-10-10T08:00',
    title: 'Green box to post office',
    color: '#6e7f29'
  },
  {
    start: '2026-10-15T09:30',
    end: '2026-10-15T10:30',
    title: 'Product team mtg.',
    color: '#f67944'
  },
  {
    start: '2026-10-23T11:00',
    end: '2026-10-23T11:45',
    title: 'Stakeholder mtg.',
    color: '#a144f6'
  },
  {
    start: '2026-10-28T13:00',
    end: '2026-10-28T13:45',
    title: "Lunch @ Butcher's",
    color: '#00aabb'
  }
])

const secondEvents = ref<MbscCalendarEvent[]>([
  {
    start: '2026-10-04T08:45',
    end: '2026-10-04T10:00',
    title: 'Quick mtg. with Martin',
    color: '#de3d83'
  },
  {
    start: '2026-10-08T15:00',
    end: '2026-10-08T16:00',
    title: 'General orientation',
    color: '#a71111'
  },
  {
    start: '2026-10-10T13:00',
    end: '2026-10-14T21:00',
    title: 'Friends binge marathon',
    color: '#7bde83'
  },
  {
    start: '2026-10-23T08:00',
    end: '2026-10-27T09:00',
    title: 'Product team mtg.',
    color: '#913aa7'
  }
])

const myView: MbscEventcalendarView = {
  calendar: { labels: 'all' }
}
const menuData = ref(defaultMenuData)
const selectValue = ref<string>('')
const menuAnchor = ref<any>(null)
const activeCalendar = ref<string>('first')
const cutCalendar = ref<string>('first')
const toDate = ref<Date>(today)
const firstToDate = ref<Date>(today)
const secondToDate = ref<Date>(today)
const originDate = ref<Date>(today)
const isMenuOpen = ref<boolean>(false)
const selectedEvents = ref<MbscCalendarEvent[]>([])
const moveEvents = ref<MbscCalendarEvent[]>([])
const pastedEvents = ref<MbscCalendarEvent[]>([])
const deletedEvents = ref<MbscCalendarEvent[]>([])
const action = ref<string>('')
const snackbarMessage = ref<string>('')
const snackbarButton = ref<any>(null)
const isSnackbarOpen = ref<boolean>(false)
const toastMessage = ref<any>(null)
const isToastOpen = ref<boolean>(false)
const dummyElm = ref<any>(null)
const menuElm = ref<any>(null)
const firstSelectedEvents = ref<MbscCalendarEvent[]>([])
const secondSelectedEvents = ref<MbscCalendarEvent[]>([])

function monthDiff(d1: Date, d2: Date) {
  return d2.getMonth() - d1.getMonth() + 12 * (d2.getFullYear() - d1.getFullYear())
}

function pasteEvents() {
  const activeEvents = getActiveEvents()
  const activeSelectedEvents = selectedEvents.value
  let eventsToUpdate = [...activeEvents]
  if (activeSelectedEvents.length > 0) {
    for (const event of activeSelectedEvents) {
      const newEvent = Object.assign({}, event)
      const startDate = new Date(event.start as string)
      const endDate = new Date(event.end as string)
      const diff = Math.abs(endDate.getTime() - startDate.getTime())

      startDate.setMonth(startDate.getMonth() - monthDiff(toDate.value, originDate.value))

      newEvent.start = startDate
      newEvent.end = new Date(startDate.getTime() + diff)

      delete newEvent.id

      eventsToUpdate = [...eventsToUpdate, newEvent]

      pastedEvents.value = [...pastedEvents.value, newEvent]
    }

    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }

    if (action.value === 'cut') {
      let cutEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
      moveEvents.value = [...selectedEvents.value]
      for (const event of selectedEvents.value) {
        cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
      }
      if (cutCalendar.value === 'first') {
        firstEvents.value = cutEvs
      } else {
        secondEvents.value = cutEvs
      }

      snackbarButton.value = {
        action: () => {
          let revertEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
          for (const event of moveEvents.value) {
            revertEvs = [...revertEvs, event]
          }
          if (cutCalendar.value === 'first') {
            firstEvents.value = revertEvs
          } else {
            secondEvents.value = revertEvs
          }

          let cutEvs = getActiveEvents()
          for (const event of pastedEvents.value) {
            cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
          }
          if (activeCalendar.value === 'first') {
            firstEvents.value = cutEvs
          } else {
            secondEvents.value = cutEvs
          }

          toastMessage.value =
            'Event' + (selectedEvents.value.length === 1 ? '' : 's') + ' reverted'
          isToastOpen.value = true
        },
        text: 'Undo'
      }
      snackbarMessage.value = 'Event' + (selectedEvents.value.length === 1 ? '' : 's') + ' pasted'
      dummyElm.value.focus()
      isSnackbarOpen.value = true
    } else {
      toastMessage.value = 'Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' pasted'
      isToastOpen.value = true
    }
    if (action.value !== 'copy') {
      selectedEvents.value = []
    }
  }
}

function getActiveEvents() {
  return activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
}

function getActiveSelectedEvents() {
  return activeCalendar.value === 'first' ? firstSelectedEvents.value : secondSelectedEvents.value
}

function deleteEvents() {
  const activeEvents = getActiveEvents()
  let eventsToUpdate = [...activeEvents]
  action.value = 'delete'
  const activeSelectedEvents = getActiveSelectedEvents()

  if (activeSelectedEvents.length > 0) {
    deletedEvents.value = activeSelectedEvents

    for (const event of activeSelectedEvents) {
      eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id)
    }

    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }

    snackbarButton.value = {
      action: () => {
        for (const event of activeSelectedEvents) {
          eventsToUpdate = [...eventsToUpdate, event]
        }
        if (activeCalendar.value === 'first') {
          firstEvents.value = eventsToUpdate
        } else {
          secondEvents.value = eventsToUpdate
        }
        deletedEvents.value = []
      },
      text: 'Undo'
    }
    snackbarMessage.value = 'Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' deleted'
    dummyElm.value.focus()
    isSnackbarOpen.value = true
  }
}

function activateAction(type: string) {
  if (selectedEvents.value.length > 0) {
    const act = type == 'copy' ? ' copied' : ' cut'
    originDate.value = toDate.value
    toastMessage.value = 'Event' + (selectedEvents.value.length === 1 ? '' : 's') + act
    isToastOpen.value = true
  }
}

function copyEvents() {
  if (activeCalendar.value === 'first') {
    if (firstSelectedEvents.value.length > 0) {
      action.value = 'copy'
      selectedEvents.value = firstSelectedEvents.value
      activateAction('copy')
    }
  } else {
    if (secondSelectedEvents.value.length > 0) {
      action.value = 'copy'
      selectedEvents.value = secondSelectedEvents.value
      activateAction('copy')
    }
  }
}

function cutEvents() {
  if (activeCalendar.value === 'first') {
    if (firstSelectedEvents.value.length > 0) {
      action.value = 'cut'
      selectedEvents.value = firstSelectedEvents.value
      cutCalendar.value = activeCalendar.value
      activateAction('cut')
      deletedEvents.value = []
    }
  } else {
    if (secondSelectedEvents.value.length > 0) {
      action.value = 'cut'
      selectedEvents.value = secondSelectedEvents.value
      cutCalendar.value = activeCalendar.value
      activateAction('cut')
      deletedEvents.value = []
    }
  }
}

function undoEvents() {
  const activeEvents = getActiveEvents()
  let eventsToUpdate = [...activeEvents]
  if (action.value === 'delete') {
    for (const event of deletedEvents.value) {
      eventsToUpdate = [...eventsToUpdate, event]
    }
    if (activeCalendar.value === 'first') {
      firstEvents.value = eventsToUpdate
    } else {
      secondEvents.value = eventsToUpdate
    }
    deletedEvents.value = []
  } else if (action.value === 'cut') {
    let revertEvs = cutCalendar.value === 'first' ? firstEvents.value : secondEvents.value
    for (const event of moveEvents.value) {
      revertEvs = [...revertEvs, event]
    }
    if (cutCalendar.value === 'first') {
      firstEvents.value = revertEvs
    } else {
      secondEvents.value = revertEvs
    }

    let cutEvs = getActiveEvents()
    for (const event of pastedEvents.value) {
      cutEvs = cutEvs.filter((ev) => ev.id !== event.id)
    }
    if (activeCalendar.value === 'first') {
      firstEvents.value = cutEvs
    } else {
      secondEvents.value = cutEvs
    }

    pastedEvents.value = []
  }
}

function detectAction(key: string) {
  switch (key) {
    case 'delete': // Delete
      deleteEvents()
      break
    case 'c': // Copy
      copyEvents()
      break
    case 'x': // Cut
      cutEvents()
      break
    case 'z': // Undo
      undoEvents()
      break
    case 'v': // Paste
      pasteEvents()
      break
  }
}

function switchCalendar(ev: any) {
  if (ev.target.value === 'first') {
    toDate.value = firstToDate.value
    secondSelectedEvents.value = []
  } else {
    toDate.value = secondToDate.value
    firstSelectedEvents.value = []
  }
}

function handlePageLoading(args: MbscPageLoadingEvent) {
  if (activeCalendar.value === 'first') {
    firstToDate.value = args.month!
  } else {
    secondToDate.value = args.month!
  }
  toDate.value = args.month!
}

function handleCellRightClick(args: MbscCellClickEvent) {
  if (!isMenuOpen.value) {
    args.domEvent.preventDefault()
    menuData.value = disabledMenu
    menuAnchor.value = args.domEvent.target
    isMenuOpen.value = true
  }
}

function handleEventRightClick(args: MbscEventClickEvent) {
  const activeEvents = activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
  if (activeEvents.length <= 1) {
    if (activeCalendar.value === 'first') {
      firstEvents.value = [args.event]
    } else {
      secondEvents.value = [args.event]
    }
  }
  args.domEvent.preventDefault()
  menuData.value = defaultMenuData
  menuAnchor.value = args.domEvent.target
  isMenuOpen.value = true
}

function handleEventDeleted(args: MbscEventDeletedEvent) {
  deletedEvents.value = args.events!
  action.value = 'delete'
  snackbarButton.value = {
    action: () => {
      const activeEvents = activeCalendar.value === 'first' ? firstEvents.value : secondEvents.value
      let eventsToUpdate = [...activeEvents]
      for (const event of deletedEvents.value) {
        eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id)
      }

      if (activeCalendar.value === 'first') {
        firstEvents.value = eventsToUpdate
      } else {
        secondEvents.value = eventsToUpdate
      }

      deletedEvents.value = []
    },
    text: 'Undo'
  }
  snackbarMessage.value = 'Event' + (deletedEvents.value.length === 1 ? '' : 's') + ' deleted'
  dummyElm.value.focus()
  isSnackbarOpen.value = true
}

function handleFirstSelectedEventsChange(args: MbscSelectedEventsChangeEvent) {
  firstSelectedEvents.value = args.events
}

function handleSecondSelectedEventsChange(args: MbscSelectedEventsChangeEvent) {
  secondSelectedEvents.value = args.events
}

function handleSelectChange(args: any) {
  detectAction(args.value)
}

function handleSelectClose() {
  isMenuOpen.value = false
  selectValue.value = ''
}

function handleKeyDown(ev: any) {
  if (ev.ctrlKey || ev.metaKey) {
    detectAction(ev.key)
  }
  if (ev.key === 'Delete') {
    detectAction('delete')
  }
}
</script>

<template>
  <MbscPage @keydown="handleKeyDown($event)">
    <div class="mbsc-flex-col md-copy-cut-paste">
      <div class="mbsc-flex-none">
        <MbscSegmentedGroup v-model="activeCalendar" @change="switchCalendar($event)">
          <MbscSegmented value="first">First calendar</MbscSegmented>
          <MbscSegmented value="second">Second calendar</MbscSegmented>
        </MbscSegmentedGroup>
      </div>
      <div class="mbsc-flex-col mbsc-flex-1-1">
        <div id="demo-copy-cut-paste-first-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="firstEvents"
            :selectedEvents="firstSelectedEvents"
            :className="activeCalendar === 'second' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleFirstSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <div id="demo-copy-cut-paste-second-cont" class="mbsc-flex-1-1 md-copy-cut-paste-cont">
          <MbscEventcalendar
            :data="secondEvents"
            :selectedEvents="secondSelectedEvents"
            :className="activeCalendar === 'first' ? 'md-hide-calendar' : ''"
            :view="myView"
            :clickToCreate="true"
            :dragToCreate="true"
            :dragToMove="true"
            :dragToResize="true"
            :selectMultipleEvents="true"
            @selected-events-change="handleSecondSelectedEventsChange"
            @page-loading="handlePageLoading"
            @cell-right-click="handleCellRightClick"
            @event-right-click="handleEventRightClick"
            @event-deleted="handleEventDeleted"
          />
        </div>
        <MbscSelect
          ref="menuElm"
          display="anchored"
          v-model="selectValue"
          :touchUi="false"
          :data="menuData"
          :anchor="menuAnchor"
          :buttons="[]"
          :isOpen="isMenuOpen"
          :inputProps="{ type: 'hidden' }"
          @change="handleSelectChange"
          @close="handleSelectClose"
        />
      </div>
    </div>
    <div ref="dummyElm" tabindex="-1"></div>
    <MbscSnackbar
      :message="snackbarMessage"
      :button="snackbarButton"
      :duration="3000"
      :isOpen="isSnackbarOpen"
      @close="isSnackbarOpen = false"
    />
    <MbscToast :message="toastMessage" :isOpen="isToastOpen" @close="isToastOpen = false" />
  </MbscPage>
</template>

<style>
.md-copy-cut-paste .mbsc-segmented {
  width: 300px;
  margin-left: auto;
  margin-right: auto;
}

.md-copy-cut-paste .md-hide-calendar {
  visibility: hidden;
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}
</style>
Move events between two event calendars using cut, copy, paste, and undo — switch calendars.

Calendar - Themes and Dark Mode

Change demo

The look and feel of the event calendar can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Calendar - Localization

Change demo

The components are fully localized. In case of the event calendar this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →

Calendar - Gregorian, Jalali & Hijri

Change demo

The event calendar supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Calendar - Event Hooks

Change demo

The event calendar ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like event-click, init, selected-date-change ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Updated on Sep 23, 2026

Modern React event calendar

Use it in responsive mobile & desktop web apps and Ionic React projects

Recurring events
Multi-day events
Popover with full event list
Drag & drop
Templating
Resource support
Customizable times
Drag & drop
Manage multiple resources
Daily, weekly or monthly timeline
Drag & drop
Customizable range
Scroll to date
Recurring events
Templating
Daily, weekly or monthly agenda

The calendar view supports everything from single to multiple week views all the way to month grids with various ways to render events.
The four views - scheduler, calendar, timeline, agenda - can be combined to create the perfect user experience on mobile, desktop and on everything in-between.

The capabilities like recurring events, all-day, multi-day events, responsiveness are supported by all views.

As part of Event calendar and scheduler it can be picked up with the Scheduling & calendaring and Complete licenses.

React Calendar Calendar for React

Calendar - Mobile Month View

Change demo

Use the event calendar for mobile, desktop and everything in-between. The content perfectly fills the parent container or the mobile screen in full width. You can choose to render an agenda below the calendar broken up into days ordered chronologically. All of this is configured in the view option.

You can use the calendar and agenda together or separately. For more ways to use the agenda learn about how to configure it.

Interested to see how the event calendar looks on largers screens with labels?  Check out the next demo →

Calendar - Desktop Month View

Change demo

Desktops or larger screens provide more space, which means you can use not just the horizontal but vertical space as well. Horizontally the calendar grows to fill the full width of the parent container while the height can be adjusted through the height option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Interested to see how the event calendar looks on smaller screens?  Check out the previous demo →

Calendar - Responsive Month View

Change demo

The event calendar is fully responsive. It adapts to the available space and fills the screen to look good everywhere. While you don't have to worry about the width the height can be manually adjusted with the height option.

Use the responsive option to configure how the calendar behaves on different sized screens. The responsive option is equipped with five breakpoints - xsmall (up to 575px), small (up to 767px), medium (up to 991px), large (up to 1199px), xlarge (from 1200px). Custom breakpoints can be added if necessary: my-custom-breakpoint: { breakpoint: 600 } (from 600px up to the next breakpoint).

Change the viewport

Calendar - Printing & PDF Export

Change demo

The event calendar includes print optimized styling through the print add-on. This needs to be added to the download package or installed separately from a dedicated NPM package.

Print styling is applied when someone prints the page that contains the calendar. In addition to that, you can call the print method on the instance which grabs only the markup of the calendar, places it onto a temporary page and calls the browsers printing function. This is especially useful when you want to add a button to only print the calendar rather than the whole page.

Besides printing, PDF export is possible through the print dialog of the browser.

The print module is not available in the trial. You can try the live demo to see how it looks.

Calendar - Event Labels

Change demo

Events can be displayed in a couple of different ways. Most of the time showing the event data inside and across the calendar cells is the way to go. When configuring the calendar object, you can set labels: true. All of this happens under the view option.

The number of visible labels are determined by the available space and the ones that don't fit will be shown in a popover. To save vertical space you can show all events in a popover.

Rather show events in a pop-over?  Take a look at the next example →

Calendar - With Event Popup

Change demo

Besides displaying events as labels, you can have them show up in a pop-over. Set it up through the calendar: {popover: true} object inside the view option. Using the popover setting saves vertical space and provides a subtle cue to the user that there are events. A small dot will appear in day cells with events or if calendar: {count: true} is set, an event count is displayed.

The same popover is rendered when events are displayed as labels and not all fit vertically in the calendar day cells.

Interested in customizing how the events look?  Take a look at how you can do it →

Calendar - Property Booking Calendar

Change demo

When keeping records of bookings, the event calendar with exact label displays can come in handy. The labels accurately mark the exact start (e.g. 14:00) and end times (e.g. 11:00) of bookings, consolidating all booking records in a single, clear view.

By combining the eventDisplay: 'exact' setting under the view option with customizable renderCalendarEventContent , you can tailor the calendar to your specific needs. This allows you to create an efficient and user-friendly booking planning UI, ensuring all your bookings are easily managed and clearly displayed.

Calendar - Custom Event Sort Order

Change demo

When rendering events, the default logic determines the order:

  • All-day events are placed at the top
  • Non-all-day events follow, sorted by their start times
  • Events with the same start time are ordered alphabetically by their title

The order property of the event data can be used to override the default ordering. The order property takes precedence over the default rules. If two events have the same order value, the default rules apply. For a more advanced order logic, the eventOrder option can be used which expects a function that compares two events and returns an order (-1 or 1).

Do you want to learn about the event ordering?  Learn more about it in the documentation →

Calendar - Timezone Configuration

Change demo

The event calendar works with local times by default, but ships with support for changing the timezone. The conversions and correct output relies on either of these three external libraries: luxon, moment-timezone and day.js. For installing and using these libraries check out this guide.

There are two angles regarding timezones:

  • dataTimezone - the calendar expects this format and returns this format. It is 'local' by default if the date-times don't contain any timezone information.

It can be set globally on the calendar using the dataTimezone option, or specifically for the event using the timezone property of the event data.

  • displayTimezone - the calendar displays the events in this timezone. The date-times will be converted from the dataTimezone and displayed accordingly. It is 'local' by default
Enable switching the timezone in the UI?  Learn how to dynamically change timezones →

Calendar - Multiple Timezone Support

Change demo

If the context requires users being able to change the timezone on the fly, you can add a custom dropdown with the desired timezones to the event calendar header. This can be of course placed externally to the calendar as well, eg. setting page.

Set the timezone of the incoming data through the dataTimezone - eg. 'utc', and set the display timezone through the displayTimezone - eg. 'America/Los_Angeles'

Calendar - Event Search Popup

Change demo

Use the available real estate in the calendar header to add event search. With the templating capabilities of the header you can easily add a search box and use a separate agenda instance to show the search results. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in a sidebar next to the event calendar using a similar search box with an inline agenda instead of a dropdown.

Calendar - Search Events

Change demo

Inline search can be easily implemented with the help of a separate agenda instance. This example is relying on a single API endpoint for getting the data onto the primary calendar view and also for getting the filtered data based on the search terms.

Events can be filtered in real time so using an agenda view for the search results is an easy choice. It provides all the necessary styling and advanced features that you might need to customize the experience.

Alternatively, search can be implemented in the header of the event calendar using a similar search box with an agenda listed in a popup instead of rendered inline.

Calendar - Week and Month View

Change demo

The calendar view supports variable weeks. Save space by only displaying one or two weeks or go for a full month where it makes sense. Use the type and size properties of the view option to set the size of the month or week view.

You can also set the first day of the week using the firstDay option, where Sunday is 0, Monday is 1, etc.

Calendar - Quarter and Year View

Change demo

Besides the single month view, the calendar can be configured to render multiple months or a year. Controlled through the calendar.type and calendar.size properties of the view option.

Depending on the height of the parent container the calendar is rendered in, the header that can be used for navigation is sticky at the top while the months are vertically scrollable.

Calendar - Show All or Limit Event Labels per Day

Change demo

Labels on the event calendar go hand in hand with the height of the event calendar rows (representing weeks). It is possible to render as many labels as fit and keep the row heights equal. The row height is liquid and determined by the height of the calendar.

If you would like to render all labels, then passing labels: 'all' will do just that. This can make the row heights variable.

Alternatively a maximum number of labels can be set by passing a number to the labels property of the view.calendar option.

If there are more events than the number of labels for a particular day, an "x more" label will help users list out all events for the day.

By default the width of the labels fill the day cells (eventDisplay: 'fill') but alternatively eventDisplay: 'exact' can be used to display the labels with exact times.

Calendar - Colored Cell Backgrounds

Change demo

Color the background of the days with the colors option. You can specify backgrounds as exact dates, ranges or set up recurring rules. The recurring object works the same way as for the events.

Use the onPageLoading lifecycle event to color backgrounds runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Want to color time ranges & days in the scheduler?  Learn how to do it →

Calendar - Day, Week and Month Views

Change demo

Dynamically switch views within one calendar instance. Use a UI control to let users do the switching or do it programmatically. This example features a segmented component inside the header, but the live option changes can be invoked from anywhere.

Switch between a month view with a monthly agenda, a week view with a weekly agenda and daily event list.

Thanks to property binding and all option changes are live and propagate accordingly.

Calendar - Navigate from External Control

Change demo

This example demonstrates how can the Eventcalendar navigated externally. Here we have a two-pane layout with a Datepicker on the left and a Calendar on the right. Changing date on the Datepicker will trigger the date change on the Calendar.

The Datepicker updates the selectedDate option of the Calendar in its onChange event, while the Calendar updates the datepicker value from its onSelectedDateChange event.

Calendar - Event Display

Change demo

You can customize the look of the labels and show additional content besides the event.title. There are two approaches you can take:

  • Only customize the content of the labels - For this you will want to use the renderCalendarEventContent option. The color and positioning of the label will be handled by the calendar. The title and any other custom fields you want to show inside the label is your responsibility.
  • Fully customize how the labels look (like in this example) - Use the renderCalendarEvent option. All original event fields along with computed fields like isMultiDay, lastDay can be leveraged for constructing the render function. With the renderCalendarEvent you will have full control over how the labels are styled including things like color, title and any custom fields.

Calendar - Event Popover

Change demo

The events listed in the popover can be customized in two ways:

  • Full event customization (like in this example) - The calendar handles the rendering of events in the correct order. Styling the content, colors and everything else is your responsibility.
  • Content customization - The calendar prints the start and end times, allDay and sets the appropriate color. Content like title and other fields can be shown.

You can provide styling to the title field and any other custom fields like description, location, participants ...

Pass a rendering function to the renderPopoverEventContent option. All original event fields along with computed fields like isMultiDay, lastDay are passed to the function. For a fully custom event rendering use the renderPopoverEvent option.

If you add custom markup you will want to add styling too. Use the popoverClass under the view option to tell the calendar what CSS class it should append to the popover container so that you can write specific CSS rules.

Calendar - Custom Header

Change demo

You can customize how the header of the event calendar looks and how the components are arranged. Besides that you can also add custom functionality, like a segmented control that lets people switch between calendar and scheduler.

Use the renderHeader option for passing a custom header layout. There are predefined components - shorthands if you will - that can be used to assemble the header:

  • Navigation component - <CalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <CalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <CalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <CalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader. This example sets a consistent order and layout across all themes and shows a custom control at the far right end.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .md-header-filter-prev { order: 1; }
            .mbsc-material .md-header-filter-next { order: 2; }
            .mbsc-material .md-header-filter-controls { order: 3; }
            .mbsc-material .md-header-filter-today { order: 4; }
Want to add a filter to the header?  Check out the next example →

Calendar - Event Tooltip

Change demo

There are several approaches to showing a tooltip when hovering events.

The native tooltip

By default, the calendar shows the browser native tooltip when hovering over the event. This includes the times and title of the event, which does the job most of the times. For showing a custom text use the tooltip property of the data object. This tooltip is specific to every event. If you want to hide the native tooltip, you can set the showEventTooltip to false.

Fully custom tooltip

Setting the showEventTooltip to false gives room for a fully custom tooltip that can be implemented by using the onEventHoverIn and onEventHoverOut lifecycle events. With the help of the Mobiscroll popup you can show a custom tooltip that holds details, actions applicable to the event it is anchored to.

Showing a third party popup

There are cases when you are using a third party library, something like md-boostrap. For those cases, turn the browser native tooltip off with the showEventTooltip option and use the third-party tooltip accordingly. In case of md-boostrap, you can add the tooltip directive to the custom event template so that the library knows where and when to show the tooltip.

Calendar - Add Event on Hover

Change demo

Hover-based interactions can be simple yet elegant. Using the onCellHoverIn and onCellHoverOut events, the calendar dynamically displays an "Add event" button when users hover over day cells, providing an intuitive way to create new events with minimal interface clutter.

For customizing the cell content appearance, the renderCalendarDayContent is the perfect candidate, as it holds the basic structure of the day cell.

Calendar - Drag and Drop

Change demo

Drag & drop is a core feature of the event calendar and it is composed of four sub-features:

  • Click to create events - double click to create events. This can be turned off or set to single click
  • Drag to create events - tap/click to start creating an event and drag to the desired length
  • Move events - grab an event and move it wherever needed
  • Resize events - change the length of an event, grab it from either end and resize it
  • Delete events - pressing the Delete or Backspace keys on the keyboard will delete the focused event

You have granular control over features through the clickToCreate, dragToCreate, dragToMove, dragToResize and eventDelete options, which are false by default.

Events can be marked as fixed by setting their editable property to false. This turns delete, drag & drop move and resize off for the event. The mbsc-event-readonly CSS class will be added to the events. This means if you would like to add opacity, override the mouse cursor or apply any other CSS override, you can add it to this class.

Calendar - Drag and Drop Permissions

Change demo

The drag & drop interactions can be fine-tuned depending on the requirements and situations. Maybe controlled by roles, event types, resources the move and resize can be turned on/off on an event basis or globally on the instance.

  • Events can be fixed in length (cannot be resized) - by setting dragToResize option to false the events cannot be resized.
  • Events can be fixed in time (cannot be moved) - by setting dragInTime option to false the events cannot be moved in time. Take in consideration that dragToMove must be set to true

To control this on an event basis, use the appropriate properties which have precedence over global calendar options.

Calendar - Drag and Drop Between Calendars

Change demo

There are certain cases when moving the events between calendars can come in handy.

Dragging and dropping events between two calendar instances can be enabled by turning on the externalDrag and externalDrop options.

Calendar - Blocked Days and Date Ranges

Change demo

Entire days and ranges can be blocked out to manage event creation and editing more efficiently.

To disable specific or recurring days you can pass an array to the invalid option. A couple of examples:

  • To disable weekends, use the recurring object - recurring: { repeat: 'weekly', weekDays: 'SA,SU' }
  • Disable a specific range - { start: new Date(2020, 11, 19), end: new Date(2020, 11, 20) }

When dragging events onto disabled days, they will automatically be denied and onEventCreateFailed / onEventUpdateFailed events will be triggered, from which custom logic can be executed to show a toast or maybe a modal for data correction. The built-in logic of how the calendar handles validation on user interaction can be controlled through the invalidateEvent option:

  • 'strict' - Strict being the default, no event overlap is allowed with invalid ranges.
  • 'start-end' - With start-end validation the calendar checks if the start or end of the event coincides with any invalid range. Other overlaps are allowed.

If you're interested in invalids for a given range (including recurring occurrences), you can use the getInvalids function.

Calendar - Double Booking Prevention

Change demo

Sometimes it is necessary to guarantee that events don't overlap - eg. when scheduling workorders, interacting with a work calendar. You can reject the updates or additions and let the user know about it.

The event overlap can be turned on/off on an event basis or globally on the instance.

  • On an event basis - by setting the overlap property to false the specified event cannot overlap.
  • Globally on the instance - by setting eventOverlap option to false overlap is disbled globally.

If set to false, the event settings have precedence over the global calendar eventOverlap option.

Give feedback to the user - optionally, a toast can be displayed to explain why an event cannot be dropped, moved or created. For this we can use the onEventCreateFailed and onEventUpdateFailed lifecycle events.

Looking to implement time off or block out ranges?  Learn how to add lunch breaks, working hours and disable weekends →

Calendar - Drag-and-Drop Task Presets

Change demo

Use external draggable events to create preset tasks that people can quickly copy and spawn events from. A great example is a car wrapping shop where different jobs need to be set up depending on the type of vehicle.

Print a list of predefined tasks and initialize them as draggable elements. Enable externalDrop for the calendar and set up the predefined event skeletons for the draggable component.

Whenever there is more information to be captured, like detailed task notes, customer information, the name of the technician... you can trigger a popup with the task form in the onEventCreate lifecycle event. For failed drops (trying to schedule a task during lunch breaks or weekends) the onEventCreateFailed event will be triggered.

Want to see how external presets look & feel for a scheduler?  Check out this example →

Calendar - External Drag and Drop from Lists

Change demo
Dragging events on the Mobiscroll event calendar

Events can be scheduled by dragging and dropping an external item onto the event calendar with Mobiscroll draggable. In order for that to work you will need to have two things set up:

  • Enable the event calendar to receive external events by setting externalDrop

to true.

  • Initialize the external events (containers) as draggable components.

Use the Draggable component to specify a skeleton event through its dragData option and reference the draggable container in the element option. The dragData accepts a full event definition that will be added to the event calendar on drop. If omitted, a default event will be created.

Working together with SortableJS and Dragula lists

Mobiscroll provides built-in support for two widely used reorderable drag-and-drop list libraries: SortableJS and Dragula. If you are already using any of these libraries to reorder list items, they can be seamlessly integrated with the event calendar. This integration enables a smooth workflow where items can be dragged from external lists and scheduled directly onto the calendar.

Events can be created and scheduled by dragging items from third-party lists into the event calendar. To enable this behavior you will need to:

  • Allow the event calendar to receive external drops by setting externalDrop to true.
  • Use the sortableJsDraggable or dragulaDraggable plugins to connect the third-party list with the scheduler.

The event data will be read from the dragged element's data-drag-data attribute, or the plugin's options expose an eventData function where the event definition (title, start, end, resource, etc.) can be specified.

You can then handle the calendars lifecycle events such as onEventCreate, onEventCreated or onEventCreateFailed to run custom logic (e.g. showing a toast) when a drop succeeds or fails.

Unscheduling events (or dragging them off a calendar)

Additionally events can be unscheduled by dragging them out from the calendar and dropping them onto an external drop container. To activate this, you will need to:

  • Enable the calendar to allow dragging events out by setting externalDrag to true.
  • Initialize the

dropcontainer.

Events can also be dropped on another event calendar with externalDrop enabled.

When an event is dropped into an external drop container or another calendar, it will be deleted from the original calendar and the onEventDelete will be fired.

You can also use the onEventDragLeave and onEventDragEnter, and the drop container's onItemDragEnter and onItemDragLeave events to provide visual feedback or running custom logic during drag.

Learn more from the external drag & drop documentation.

Unscheduling events to SortableJS and Dragula lists

Dropping events from the Eventcalendar to SortableJS and Dragula lists is also possible with the sortableJsDraggable and dragulaDraggable plugins. To enable this behavior you will need to set the following under the options configuration:

  • Allow the list to receive external drops by setting exteralDrop to true
  • Use the onExternalDrop callback to update the content of the third-party list. The function arguments return the afterElement - the list element before which the clone is dropped,

container - the list container, dragData - the dragged event data, position - the index where the clone is dropped on the list.

For details, and option lists see the Third-party dragging support section in the documentation

Looking for external drag into a scheduler?  Check out this example →

Calendar - Resource Filter in Header

Change demo

The calendar view doesn't have built in resource listing, however we can easily solve that inside the header using the segmented component. The header of the agenda is a canvas and an opportunity for customization. You can add custom components and enable new interaction in context.

Such an example would be a custom filter block created with the help of a segmented control and placed between the standard UI components, which are:

  • Navigation component - <CalendarNav />. Use the .md-header-filter-controls CSS class for custom overrides.
  • Today button - <CalendarToday />. Use the .md-header-filter-today CSS class for custom overrides.
  • Previous month button - <CalendarPrev />. Use the .md-header-filter-prev CSS class for custom overrides.
  • Next month button - <CalendarNext />. Use the .md-header-filter-next CSS class for custom overrides.

For changing the order the controls are laid out, you only need to set up the renderHeader.

Overriding the order for specific themes

For a custom order on a theme to theme basis, you will need to use a little CSS. Flex layout makes reordering easy. It's just a matter of setting the order in CSS. For material use the .mbsc-material, for windows the .mbsc-windows prefix and for iOS it is .mbsc-ios class. Eg.:

.mbsc-material .mds-header-filter-prev { order: 1; }
            .mbsc-material .mds-header-filter-next { order: 2; }
            .mbsc-material .mds-header-filter { order: 3; }
            .mbsc-material .mds-header-filter-today { order: 4; }
Want to style and reorder the header?  Take a look at the previous example →

Calendar - Day Cell Summary View

Change demo

This demo showcases an advanced event calendar implementation with extensive day cell customization using the renderCalendarDay , which completely overrides the default cell rendering.

The calendar provides a comprehensive visual overview of scheduling density and workload management through custom aggregate data visualization with stress-level indicators, weather information, and color-coded backgrounds.

This approach prevents the calendar from rendering individual event labels, allowing full control over the cell content. Each day cell displays aggregate information calculated from the actual events, received by the custom template.

Users can navigate smoothly from the monthly or weekly overview to a detailed daily schedule by clicking on a day cell, which highlights the selected day and loads all events. A convenient back button allows a quick return to the previous view. Each cell also includes an add button for creating new appointments, and events can be added by dragging or clicking in the week or day view.

Calendar - Event Data Structure

Change demo

The event data structure for the calendar is straightforward with a couple of base properties that the component understands and uses to render the UI. Besides the base properties you can add any custom property, like location, description ...

  • id - A unique ID for the event. If not specified a unique id will be generated
  • title - Defines the event text. This can be plaintext or HTML
  • tooltip - Defines the text for the tooltip which appears on mouse hover. If not specified, it will show the title and the start/end times of the event.
  • color - Defines the event color
  • start - Sets the start date and time for the event. It can be a js date object, ISO date string or moment.js object. Learn about date formats
  • end - Sets the end date and time for the event. The same formats are supported as for start
  • allDay - Configures the event as a full-day event
  • recurring - Configures the recurring rules for the event. Learn about recurring events
  • recurringException - Represents the exceptions of a recurring event, when specific dates need to be skipped from the rule.
  • recurringExceptionRule - Represents the exception rule of a recurring event, when recurring dates need to be skipped from the rule.
  • resource - Links the event to one or more resources. Expects a list of IDs part of the resources array.
  • timezone - The timezone where the event takes place. If specified, it takes precedence over the calendar's specified dataTimezone.
  • dragInTime - Specifies whether the event is movable in time. If set to false has precedence over the dragInTime option of the calendar.
  • resize - Specifies whether the event is resizable. If set to false has precedence over the dragToResize option of the calendar.
  • overlap - Specifies whether overlap is allowed on the event. If set to false has precedence over the eventOverlap option of the calendar.
  • editable - Denotes if the event is editable. If set false, the event cannot be dragged, resized or deleted even if globally enabled
  • cssClass - A custom css class for the event. Useful for quick styling adjustments of the event container.
  • bufferBefore - Defines a buffer time in minutes that happens before the start of the event. This buffer area can help you visualise delays or added minutes for tasks. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • bufferAfter - Defines a buffer time in minutes that happens after the end of the event. It is not automatically rendered in case of the calendar view, but can be used in the custom template.
  • order - Specifies the order of the event in the event array. Has precedence over the default ordering rules.

Calendar - Date Format Inputs

Change demo

Understanding how to work with dates inside the event calendar is essential. You can pass to the data, marked, colors and labels in four different formats. The event calendar can work with Javascript date objects, ISO strings and Moment.js objects.

Calendar - Recurring Events

Change demo

Configure daily, weekly, monthly and yearly recurring events. On top of setting up recurrence, you can exclude specific and recurring days. This is especially useful in cases when a single occurrence of an event is deleted or is moved to a different time.

You can pass the recurrence rule in the recurring property of the event as an object or a string in RRULE format. Learn about the event data structure and where to place the recurring rules.

Use the configurator to experiment, build strings and objects that you can grab and use.

Interested in adding recurrence configuration to your UI?  Take a look at this add/edit dialog →

Calendar - Inline Events

Change demo

What is an event calendar without any events in it? To populate it with events all you have to do is pass the event array to the data option.

In a real-world scenario you would probably load the events from a remote resource or event better, load them on demand. However the point of this example is to understand how easy it is to add events to the event calendar.

Do you want to learn about the event data sctructure?  See how the event object is built →

Calendar - Load Events from API

Change demo

The calendar can be populated by passing an array to the data option, that you can construct either inline or by getting it from a remote API. The important thing to remember is that events need to be in a format that the calendar understands.

Interested in load on demand?  Dynamically load events on month change →

Calendar - Load Events on Demand

Change demo

The event calendar supports remote and local data sources. Besides that, events can be populated on initialization or loaded on demand.

Getting the events in real time as the user navigates improves load performance and always serves the most recent data.

Use the onPageLoading lifecycle event to load the data runtime. You can learn about lifecycle events and places where to drop logic to customize the experience.

Interested in loading events from Google Calendar?  Show events from Google Calendar →

Calendar - Google Calendar Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Google calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Outlook Integration

Change demo

The event calendar comes with third party calendar integration support through the integration plugin. This needs to be added to the download package or installed separately from a dedicated NPM package.

It includes everything you need to authenticate your users, get their Outlook calendars and provides functions for CRUD operations. It takes care of loading the events and converts them to the required format so that they can be displayed on the Mobiscroll calendar separately or mixed with other calendars and events.

Customizing the interaction, event workflows, whether the events are read-only is up to you. In this live demo, newly created events will land in the primary calendar of the authenticated user.

This example uses the integration plugin to connect to and load events from Outlook Calendars and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Public Google Calendar Integration

Change demo

Event data can be loaded from remote sources, like public google calendars. Through the integration plugin you can easily show events that are available in a public calendar. The integration plugin needs to be added to the download package or installed separately from a dedicated NPM package.

You will just need the CALENDAR_ID and an apiKey from google and you should be ready to roll.

Public calendars are read-only. If you are interested in syncing private google calendars with read/write/delete access, check out this example.

This example uses the integration plugin to connect to and load events from Google Calendar and it is not available in the trial. Give the live demo a try and see how it can be configured.

Calendar - Add, Edit and Delete Events

Change demo
Create new events

Drag to create and click to create is enabled. Events can be created by dragging or with double clicks. As soon as the initial position is confirmed, a temporary event is created and a custom edit dialog is shown for refinement. On cancel the temporary event will be removed and on confirmation the event will stay in the calendar.

Edit existing events

Drag to resize and drag to move is enabled. Events can be reordered and resized. In addition to that, clicking on the event will open a custom dialog that enables editing the various properties.

Delete events

Delete can be implemented inside the edit dialog with a button. It's just a matter of removing it from the data object. If a dialog is not shown on click, focused events can be deleted with the backspace and delete keys.

Interested in adding recurrence configuration?  Check out the next example →

Calendar - Recurring Events Editor

Change demo

As seen in the previous example, an add/edit form can be created with custom and base event fields. While the CRUD example features delete with undo, this example shows off how to build a fully customizable recurrence editor right in the add/edit screen.

Above some common presets, like Daily, Weekly on X day, Monthly on Xth, Annually on the same day, Every Weekday a fully custom recurrence editor is implemented.

Copy & paste or delve into the code and understand how to generate recurrence objects or RRULES as seen in this live rule builder.

Calendar - Block Past Event Creation

Change demo

Sometimes we don't want users to be able to create events in the past or to alter past events. This might be role based in some cases or applied in general to the calendar.

To disable past event creation and manipulation, a couple of things need to be handled:

  • Invalidate dates that are before today - this takes care of validating event drop and event creation on past dates
  • Mark past events as fixed - to do this, set the editable property of the event object to false for the events that should remain fixed
  • Handle past occurrences of recurring events - recurring events are loaded as a single event and the occurrences are generated by the event calendar. Moving the past occurrences need to be handled in the

onEventUpdate and onEventCreate lifecycle events

  • Give feedback to the user - optionally, a toast can be displayed to give feedback to the user why an event cannot be dropped, moved and created in the past. For this we can use the

onEventCreateFailed and onEventUpdateFailed lifecycle events

Calendar - Bulk Actions — Edit, Delete & Update Events

Change demo
Bulk Actions — Edit, Delete & Update Events
Get started with this example

Multiple event selection can be turned on with the selectMultipleEvents option. Selecting multiple events can be done through user interaction with CTRL/SHIFT/CMD + click or programmatically eg. click of a button or 'select all' checkbox.

Bulk operations like delete, update can be applied the selected events. Things like deleting with the backspace or delete buttons work out of the box but custom actions can be also applied. The selection can be easily retrieved and updated with the getSelectedEvents and setSelectedEvents method.

Custom actions can be performed with external buttons or with context menu activated on right-click.

Interested in moving events between two separate calendars?  Check out the next example for cut, copy, paste events →

Calendar - Cut, Copy, Paste Events

Change demo

While copy & pasting one or more events is useful, sometimes being able to move events between two separate calendars can improve productivity. How the calendars are laid out depends on the application, but the basic idea is that you will need to be able to tell where the events from the clipboard will be pasted.

In this example this is implemented by tracking the active instance, which is determined by the active tab of the segmented control. With this out of the way, CTRL/CMD+C/X/Z/V handle the copy, cut, undo and paste actions.

Looking for multiple event selection & bulk operations?  Take a look at the previous example →
Copy code
import { Eventcalendar, Page, Segmented, SegmentedGroup, Select, setOptions, Snackbar, Toast  } from '@mobiscroll/react';
import { useCallback, useMemo, useRef, useState } from 'react';

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

const today = new Date();

function App() {
  const menu = useMemo(
    () => [
      { text: 'Copy', value: 'c' },
      { text: 'Cut', value: 'x' },
      { text: 'Paste', value: 'v' },
      { text: 'Delete', value: 'delete' },
    ],
    [],
  );

  const disabledMenu = useMemo(
    () => [
      { text: 'Copy', value: 'c', disabled: true },
      { text: 'Cut', value: 'x', disabled: true },
      { text: 'Paste', value: 'v' },
      { text: 'Delete', value: 'delete', disabled: true },
    ],
    [],
  );

  const [selectValue, setSelectValue] = useState();
  const [menuAnchor, setMenuAnchor] = useState();
  const [activeCalendar, setActiveCalendar] = useState('first');
  const [cutCalendar, setCutCalendar] = useState('first');
  const [toDate, setToDate] = useState(today);
  const [firstToDate, setFirstToDate] = useState(today);
  const [secondToDate, setSecondToDate] = useState(today);
  const [originDate, setOriginDate] = useState(today);
  const [menuOpen, setMenuOpen] = useState(false);
  const [menuData, setMenuData] = useState(menu);
  const [firstSelectedEvents, setFirstSelectedEvents] = useState([]);
  const [secondSelectedEvents, setSecondSelectedEvents] = useState([]);
  const [selectedEvents, setSelectedEvents] = useState([]);
  const [moveEvents, setMoveEvents] = useState([]);
  const [pastedEvents, setPastedEvents] = useState([]);
  const [deletedEvents, setDeletedEvents] = useState([]);
  const [isToastOpen, setToastOpen] = useState(false);
  const [toastMessage, setToastMessage] = useState('');
  const [isSnackbarOpen, setSnackbarOpen] = useState(false);
  const [snackbarMessage, setSnackbarMessage] = useState('');
  const [snackbarButton, setSnackbarButton] = useState();
  const [firstEvents, setFirstEvents] = useState([
    {
      start: '2026-10-02T09:00',
      end: '2026-10-06T18:00',
      title: 'Business of Software Conference',
      color: '#ff6d42',
    },
    {
      start: '2026-10-10T07:00',
      end: '2026-10-10T08:00',
      title: 'Green box to post office',
      color: '#6e7f29',
    },
    {
      start: '2026-10-15T09:30',
      end: '2026-10-15T10:30',
      title: 'Product team mtg.',
      color: '#f67944',
    },
    {
      start: '2026-10-23T11:00',
      end: '2026-10-23T11:45',
      title: 'Stakeholder mtg.',
      color: '#a144f6',
    },
    {
      start: '2026-10-28T13:00',
      end: '2026-10-28T13:45',
      title: "Lunch @ Butcher's",
      color: '#00aabb',
    },
  ]);
  const [secondEvents, setSecondEvents] = useState([
    {
      start: '2026-10-04T08:45',
      end: '2026-10-04T10:00',
      title: 'Quick mtg. with Martin',
      color: '#de3d83',
    },
    {
      start: '2026-10-08T15:00',
      end: '2026-10-08T16:00',
      title: 'General orientation',
      color: '#a71111',
    },
    {
      start: '2026-10-10T13:00',
      end: '2026-10-14T21:00',
      title: 'Friends binge marathon',
      color: '#7bde83',
    },
    {
      start: '2026-10-23T08:00',
      end: '2026-10-27T09:00',
      title: 'Product team mtg.',
      color: '#913aa7',
    },
  ]);

  const dummyRef = useRef();
  const isMenuOpen = useRef();
  const action = useRef();

  const myView = useMemo(() => ({ calendar: { labels: 'all' } }), []);

  const handleToastClose = useCallback(() => {
    setToastOpen(false);
  }, []);

  const handleSnackbarClose = useCallback(() => {
    setSnackbarOpen(false);
  }, []);

  const handlePageLoading = useCallback(
    (args) => {
      setTimeout(() => {
        if (activeCalendar === 'first') {
          setFirstToDate(args.month);
        } else {
          setSecondToDate(args.month);
        }
        setToDate(args.month);
      });
    },
    [activeCalendar],
  );

  const handleCellRightClick = useCallback(
    (args) => {
      if (!isMenuOpen.current) {
        args.domEvent.preventDefault();
        setMenuData(disabledMenu);
        setMenuAnchor(args.domEvent.target);
        setTimeout(() => {
          setMenuOpen(true);
        });
      }
    },
    [isMenuOpen, disabledMenu],
  );

  const handleEventRightClick = useCallback(
    (args) => {
      const activeEvents = activeCalendar === 'first' ? firstEvents : secondEvents;
      if (activeEvents.length <= 1) {
        if (activeCalendar === 'first') {
          setFirstEvents([args.event]);
        } else {
          setSecondEvents([args.event]);
        }
      }
      if (activeCalendar === 'first' && firstSelectedEvents.length <= 1) {
        setFirstSelectedEvents([args.event]);
      }
      if (activeCalendar === 'second' && secondSelectedEvents.length <= 1) {
        setSecondSelectedEvents([args.event]);
      }
      args.domEvent.preventDefault();
      setMenuData(menu);
      setMenuAnchor(args.domEvent.target);
      setTimeout(() => {
        setMenuOpen(true);
      });
      isMenuOpen.current = true;
    },
    [activeCalendar, firstEvents, secondEvents, firstSelectedEvents, secondSelectedEvents, menu],
  );

  const handleEventDeleted = useCallback(
    (args) => {
      setDeletedEvents(args.events);
      action.current = 'delete';
      setTimeout(() => {
        setSnackbarButton({
          action: () => {
            const activeEvents = activeCalendar === 'first' ? firstEvents : secondEvents;
            let eventsToUpdate = [...activeEvents];
            for (const event of deletedEvents) {
              eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id);
            }

            if (activeCalendar === 'first') {
              setFirstEvents(eventsToUpdate);
            } else {
              setSecondEvents(eventsToUpdate);
            }

            setDeletedEvents([]);
          },
          text: 'Undo',
        });
        setSnackbarMessage('Event' + (deletedEvents.length === 1 ? '' : 's') + ' deleted');
        setSnackbarOpen(true);
      });
      dummyRef.current.focus();
    },
    [activeCalendar, deletedEvents, firstEvents, secondEvents],
  );

  const getActiveEvents = useCallback(
    () => (activeCalendar === 'first' ? firstEvents : secondEvents),
    [activeCalendar, firstEvents, secondEvents],
  );

  const getActiveSelectedEvents = useCallback(
    () => (activeCalendar === 'first' ? firstSelectedEvents : secondSelectedEvents),
    [activeCalendar, firstSelectedEvents, secondSelectedEvents],
  );

  const monthDiff = useCallback((d1, d2) => d2.getMonth() - d1.getMonth() + 12 * (d2.getFullYear() - d1.getFullYear()), []);

  const pasteEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    const activeSelectedEvents = selectedEvents;
    let eventsToUpdate = [...activeEvents];
    if (activeSelectedEvents.length > 0) {
      for (const event of activeSelectedEvents) {
        const newEvent = Object.assign({}, event);
        const startDate = new Date(event.start);
        const endDate = new Date(event.end);
        const diff = Math.abs(endDate - startDate);

        newEvent.start = startDate.setMonth(startDate.getMonth() - monthDiff(toDate, originDate));
        newEvent.end = new Date(startDate.getTime() + diff);

        delete newEvent.id;

        eventsToUpdate = [...eventsToUpdate, newEvent];

        setPastedEvents([...pastedEvents, newEvent]);
      }

      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }

      if (action.current === 'cut') {
        let cutEvs = activeCalendar === cutCalendar ? eventsToUpdate : cutCalendar === 'first' ? firstEvents : secondEvents;
        setMoveEvents([...selectedEvents]);
        for (const event of selectedEvents) {
          cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
        }
        if (cutCalendar === 'first') {
          setFirstEvents(cutEvs);
        } else {
          setSecondEvents(cutEvs);
        }

        setTimeout(() => {
          setSnackbarButton({
            action: () => {
              let revertEvs = cutCalendar === 'first' ? firstEvents : secondEvents;
              for (const event of moveEvents) {
                revertEvs = [...revertEvs, event];
              }
              if (cutCalendar === 'first') {
                setFirstEvents(revertEvs);
              } else {
                setSecondEvents(revertEvs);
              }

              let cutEvs = getActiveEvents();
              for (const event of pastedEvents) {
                cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
              }
              if (activeCalendar === 'first') {
                setFirstEvents(cutEvs);
              } else {
                setSecondEvents(cutEvs);
              }

              setToastMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + ' reverted');
              setToastOpen(true);
            },
            text: 'Undo',
          });
          setSnackbarMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + ' pasted');
          setSnackbarOpen(true);
        });
        dummyRef.current.focus();
      } else {
        setToastMessage('Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' pasted');
        setToastOpen(true);
      }
      if (action.current !== 'copy') {
        setSelectedEvents([]);
      }
    }
  }, [
    action,
    activeCalendar,
    cutCalendar,
    firstEvents,
    getActiveEvents,
    monthDiff,
    moveEvents,
    originDate,
    pastedEvents,
    secondEvents,
    selectedEvents,
    toDate,
  ]);

  const deleteEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    let eventsToUpdate = [...activeEvents];
    action.current = 'delete';
    const activeSelectedEvents = getActiveSelectedEvents();

    if (activeSelectedEvents.length > 0) {
      setDeletedEvents(activeSelectedEvents);

      for (const event of activeSelectedEvents) {
        eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id);
      }

      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }
      setTimeout(() => {
        setSnackbarButton({
          action: () => {
            for (const event of activeSelectedEvents) {
              eventsToUpdate = [...eventsToUpdate, event];
            }
            if (activeCalendar === 'first') {
              setFirstEvents(eventsToUpdate);
            } else {
              setSecondEvents(eventsToUpdate);
            }
            setDeletedEvents([]);
          },
          text: 'Undo',
        });
        setSnackbarMessage('Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' deleted');
        setSnackbarOpen(true);
      });
      dummyRef.current.focus();
    }
  }, [activeCalendar, getActiveEvents, getActiveSelectedEvents]);

  const activateAction = useCallback(
    (type) => {
      if (selectedEvents.length > 0) {
        const act = type == 'copy' ? ' copied' : ' cut';
        setOriginDate(toDate);
        setToastMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + act);
        setToastOpen(true);
      }
    },
    [selectedEvents, toDate],
  );

  const copyEvents = useCallback(() => {
    if (activeCalendar === 'first') {
      if (firstSelectedEvents.length > 0) {
        action.current = 'copy';
        setSelectedEvents(firstSelectedEvents);
        activateAction('copy');
      }
    } else {
      if (secondSelectedEvents.length > 0) {
        action.current = 'copy';
        setSelectedEvents(secondSelectedEvents);
        activateAction('copy');
      }
    }
  }, [activateAction, activeCalendar, firstSelectedEvents, secondSelectedEvents]);

  const cutEvents = useCallback(() => {
    if (activeCalendar === 'first') {
      if (firstSelectedEvents.length > 0) {
        action.current = 'cut';
        setSelectedEvents(firstSelectedEvents);
        setCutCalendar(activeCalendar);
        activateAction('cut');
        setDeletedEvents([]);
      }
    } else {
      if (secondSelectedEvents.length > 0) {
        action.current = 'cut';
        setSelectedEvents(secondSelectedEvents);
        setCutCalendar(activeCalendar);
        activateAction('cut');
        setDeletedEvents([]);
      }
    }
  }, [activateAction, activeCalendar, firstSelectedEvents, secondSelectedEvents]);

  const undoEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    let eventsToUpdate = [...activeEvents];
    if (action.current === 'delete') {
      for (const event of deletedEvents) {
        eventsToUpdate = [...eventsToUpdate, event];
      }
      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }
      setDeletedEvents([]);
    } else if (action.current === 'cut') {
      let revertEvs = cutCalendar === 'first' ? firstEvents : secondEvents;
      for (const event of moveEvents) {
        revertEvs = [...revertEvs, event];
      }
      if (cutCalendar === 'first') {
        setFirstEvents(revertEvs);
      } else {
        setSecondEvents(revertEvs);
      }

      let cutEvs = getActiveEvents();
      for (const event of pastedEvents) {
        cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
      }
      if (activeCalendar === 'first') {
        setFirstEvents(cutEvs);
      } else {
        setSecondEvents(cutEvs);
      }

      setMoveEvents([]);
      setPastedEvents([]);
    }
  }, [action, activeCalendar, cutCalendar, deletedEvents, firstEvents, getActiveEvents, moveEvents, pastedEvents, secondEvents]);

  const detectAction = useCallback(
    (key) => {
      switch (key) {
        case 'delete': // Delete
          deleteEvents();
          break;
        case 'c': // Copy
          copyEvents();
          break;
        case 'x': // Cut
          cutEvents();
          break;
        case 'z': // Undo
          undoEvents();
          break;
        case 'v': // Paste
          pasteEvents();
          break;
        default:
      }
    },
    [copyEvents, cutEvents, deleteEvents, pasteEvents, undoEvents],
  );

  const handleFirstSelectedEventsChange = useCallback((args) => {
    setFirstSelectedEvents(args.events);
  }, []);

  const handleSecondSelectedEventsChange = useCallback((args) => {
    setSecondSelectedEvents(args.events);
  }, []);

  const handleSelectChange = useCallback(
    (args) => {
      setSelectValue(args.value);
      detectAction(args.value);
    },
    [detectAction],
  );

  const handleSelectClose = useCallback(() => {
    isMenuOpen.current = false;
    setMenuOpen(false);
    // Clear selection
    setSelectValue(null);
  }, []);

  const switchCalendar = useCallback(
    (ev) => {
      setActiveCalendar(ev.target.value);
      if (ev.target.value === 'first') {
        setToDate(firstToDate);
        setSecondSelectedEvents([]);
      } else {
        setToDate(secondToDate);
        setFirstSelectedEvents([]);
      }
    },
    [firstToDate, secondToDate],
  );

  const handleKeyDown = (ev) => {
    if (ev.ctrlKey || ev.metaKey) {
      detectAction(ev.key);
    }
    if (ev.key === 'Delete') {
      detectAction('delete');
    }
  };

  return (
    <Page>
      <div onKeyDown={handleKeyDown}>
        <div className="mbsc-flex-col md-copy-cut-paste">
          <div className="mbsc-flex-none">
            <SegmentedGroup name="controlled" onChange={switchCalendar}>
              <Segmented value="first" checked={activeCalendar === 'first'}>
                First calendar
              </Segmented>
              <Segmented value="second" checked={activeCalendar === 'second'}>
                Second calendar
              </Segmented>
            </SegmentedGroup>
          </div>
          <div className="mbsc-flex-col mbsc-flex-1-1">
            <div id="demo-copy-cut-paste-first-cont" className="mbsc-flex-1-1 md-copy-cut-paste-cont">
              <Eventcalendar
                className={activeCalendar === 'first' ? '' : 'md-hide-calendar'}
                view={myView}
                clickToCreate={true}
                dragToCreate={true}
                dragToMove={true}
                dragToResize={true}
                selectMultipleEvents={true}
                data={firstEvents}
                selectedEvents={firstSelectedEvents}
                onSelectedEventsChange={handleFirstSelectedEventsChange}
                onPageLoading={handlePageLoading}
                onCellRightClick={handleCellRightClick}
                onEventRightClick={handleEventRightClick}
                onEventDeleted={handleEventDeleted}
              />
            </div>
            <div id="demo-copy-cut-paste-second-cont" className="mbsc-flex-1-1 md-copy-cut-paste-cont">
              <Eventcalendar
                className={activeCalendar === 'second' ? '' : 'md-hide-calendar'}
                view={myView}
                clickToCreate={true}
                dragToCreate={true}
                dragToMove={true}
                dragToResize={true}
                selectMultipleEvents={true}
                data={secondEvents}
                selectedEvents={secondSelectedEvents}
                onSelectedEventsChange={handleSecondSelectedEventsChange}
                onPageLoading={handlePageLoading}
                onCellRightClick={handleCellRightClick}
                onEventRightClick={handleEventRightClick}
                onEventDeleted={handleEventDeleted}
              />
            </div>
            <Select
              touchUi={false}
              display="anchored"
              anchor={menuAnchor}
              isOpen={menuOpen}
              buttons={[]}
              data={menuData}
              value={selectValue}
              onChange={handleSelectChange}
              onClose={handleSelectClose}
              inputProps={{ type: 'hidden' }}
            />
          </div>
        </div>
        <div tabIndex={-1} ref={dummyRef}></div>
      </div>
      <Toast isOpen={isToastOpen} message={toastMessage} onClose={handleToastClose} />
      <Snackbar isOpen={isSnackbarOpen} duration={3000} message={snackbarMessage} button={snackbarButton} onClose={handleSnackbarClose} />
    </Page>
  );
}

export default App;
import {
  Eventcalendar,
  MbscCalendarEvent,
  MbscCellClickEvent,
  MbscEventcalendarView,
  MbscEventClickEvent,
  MbscEventDeletedEvent,
  MbscPageLoadingEvent,
  MbscSelectChangeEvent,
  MbscSelectedEventsChangeEvent,
  Page,
  Segmented,
  SegmentedGroup,
  Select,
  setOptions,
  Snackbar,
  Toast ,
} from '@mobiscroll/react';
import { ChangeEvent, FC, KeyboardEvent, useCallback, useRef, useState } from 'react';

setOptions({
  locale:  ,
  theme: ' ',
  themeVariant: ' '
});

const today = new Date();

const viewSettings: MbscEventcalendarView = {
  calendar: { labels: 'all' },
};
const menu = [
  { text: 'Copy', value: 'c' },
  { text: 'Cut', value: 'x' },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete' },
];
const disabledMenu = [
  { text: 'Copy', value: 'c', disabled: true },
  { text: 'Cut', value: 'x', disabled: true },
  { text: 'Paste', value: 'v' },
  { text: 'Delete', value: 'delete', disabled: true },
];

const App: FC = () => {
  const [selectValue, setSelectValue] = useState(null);
  const [menuAnchor, setMenuAnchor] = useState<HTMLElement>();
  const [activeCalendar, setActiveCalendar] = useState<string>('first');
  const [cutCalendar, setCutCalendar] = useState<string>('first');
  const [toDate, setToDate] = useState(new Date());
  const [firstToDate, setFirstToDate] = useState(today);
  const [secondToDate, setSecondToDate] = useState(today);
  const [originDate, setOriginDate] = useState(today);
  const [menuOpen, setMenuOpen] = useState<boolean>(false);
  const [menuData, setMenuData] = useState(menu);
  const [firstSelectedEvents, setFirstSelectedEvents] = useState<MbscCalendarEvent[]>([]);
  const [secondSelectedEvents, setSecondSelectedEvents] = useState<MbscCalendarEvent[]>([]);
  const [selectedEvents, setSelectedEvents] = useState<MbscCalendarEvent[]>([]);
  const [moveEvents, setMoveEvents] = useState<MbscCalendarEvent[]>([]);
  const [pastedEvents, setPastedEvents] = useState<MbscCalendarEvent[]>([]);
  const [deletedEvents, setDeletedEvents] = useState<MbscCalendarEvent[]>([]);
  const [isToastOpen, setToastOpen] = useState(false);
  const [toastMessage, setToastMessage] = useState('');
  const [isSnackbarOpen, setSnackbarOpen] = useState(false);
  const [snackbarMessage, setSnackbarMessage] = useState('');
  const [snackbarButton, setSnackbarButton] = useState<{ action: () => void; text: string }>();

  const [firstEvents, setFirstEvents] = useState<MbscCalendarEvent[]>([
    {
      start: '2026-10-02T09:00',
      end: '2026-10-06T18:00',
      title: 'Business of Software Conference',
      color: '#ff6d42',
    },
    {
      start: '2026-10-10T07:00',
      end: '2026-10-10T08:00',
      title: 'Green box to post office',
      color: '#6e7f29',
    },
    {
      start: '2026-10-15T09:30',
      end: '2026-10-15T10:30',
      title: 'Product team mtg.',
      color: '#f67944',
    },
    {
      start: '2026-10-23T11:00',
      end: '2026-10-23T11:45',
      title: 'Stakeholder mtg.',
      color: '#a144f6',
    },
    {
      start: '2026-10-28T13:00',
      end: '2026-10-28T13:45',
      title: "Lunch @ Butcher's",
      color: '#00aabb',
    },
  ]);

  const [secondEvents, setSecondEvents] = useState<MbscCalendarEvent[]>([
    {
      start: '2026-10-04T08:45',
      end: '2026-10-04T10:00',
      title: 'Quick mtg. with Martin',
      color: '#de3d83',
    },
    {
      start: '2026-10-08T15:00',
      end: '2026-10-08T16:00',
      title: 'General orientation',
      color: '#a71111',
    },
    {
      start: '2026-10-10T13:00',
      end: '2026-10-14T21:00',
      title: 'Friends binge marathon',
      color: '#7bde83',
    },
    {
      start: '2026-10-23T08:00',
      end: '2026-10-27T09:00',
      title: 'Product team mtg.',
      color: '#913aa7',
    },
  ]);

  const dummyRef = useRef<HTMLDivElement>(null);
  const isMenuOpen = useRef<boolean>(false);
  const action = useRef<string>(undefined);

  const handleToastClose = useCallback(() => {
    setToastOpen(false);
  }, []);

  const handleSnackbarClose = useCallback(() => {
    setSnackbarOpen(false);
  }, []);

  const handlePageLoading = useCallback(
    (args: MbscPageLoadingEvent) => {
      setTimeout(() => {
        if (activeCalendar === 'first') {
          setFirstToDate(args.month!);
        } else {
          setSecondToDate(args.month!);
        }
        setToDate(args.month!);
      });
    },
    [activeCalendar],
  );

  const handleCellRightClick = useCallback(
    (args: MbscCellClickEvent) => {
      if (!isMenuOpen.current) {
        args.domEvent.preventDefault();
        setMenuData(disabledMenu);
        setMenuAnchor(args.target);
        setTimeout(() => {
          setMenuOpen(true);
        });
      }
    },
    [isMenuOpen],
  );

  const handleEventRightClick = useCallback(
    (args: MbscEventClickEvent) => {
      const activeEvents = activeCalendar === 'first' ? firstEvents : secondEvents;
      if (activeEvents.length <= 1) {
        if (activeCalendar === 'first') {
          setFirstEvents([args.event]);
        } else {
          setSecondEvents([args.event]);
        }
      }
      args.domEvent.preventDefault();
      setMenuData(menu);
      setMenuAnchor(args.domEvent.target);
      setTimeout(() => {
        setMenuOpen(true);
      });
      isMenuOpen.current = true;
    },
    [activeCalendar, firstEvents, secondEvents],
  );

  const handleEventDeleted = useCallback(
    (args: MbscEventDeletedEvent) => {
      setDeletedEvents(args.events!);
      action.current = 'delete';
      setTimeout(() => {
        setSnackbarButton({
          action: () => {
            const activeEvents = activeCalendar === 'first' ? firstEvents : secondEvents;
            let eventsToUpdate = [...activeEvents];
            for (const event of deletedEvents) {
              eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id);
            }

            if (activeCalendar === 'first') {
              setFirstEvents(eventsToUpdate);
            } else {
              setSecondEvents(eventsToUpdate);
            }

            setDeletedEvents([]);
          },
          text: 'Undo',
        });
        setSnackbarMessage('Event' + (deletedEvents.length === 1 ? '' : 's') + ' deleted');
        setSnackbarOpen(true);
      });
      dummyRef.current!.focus();
    },
    [activeCalendar, deletedEvents, firstEvents, secondEvents],
  );

  const getActiveEvents = useCallback(
    () => (activeCalendar === 'first' ? firstEvents : secondEvents),
    [activeCalendar, firstEvents, secondEvents],
  );

  const getActiveSelectedEvents = useCallback(
    () => (activeCalendar === 'first' ? firstSelectedEvents : secondSelectedEvents),
    [activeCalendar, firstSelectedEvents, secondSelectedEvents],
  );

  const monthDiff = useCallback((d1: Date, d2: Date) => d2.getMonth() - d1.getMonth() + 12 * (d2.getFullYear() - d1.getFullYear()), []);

  const pasteEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    const activeSelectedEvents = selectedEvents;
    let eventsToUpdate = [...activeEvents];
    if (activeSelectedEvents.length > 0) {
      for (const event of activeSelectedEvents) {
        const newEvent = Object.assign({}, event);
        const startDate = new Date(event.start as string);
        const endDate = new Date(event.end as string);
        const diff = Math.abs(+endDate - +startDate);

        newEvent.start = new Date(startDate.setMonth(startDate.getMonth() - monthDiff(toDate, originDate)));
        newEvent.end = new Date(startDate.getTime() + diff);

        delete newEvent.id;

        eventsToUpdate = [...eventsToUpdate, newEvent];

        setPastedEvents([...pastedEvents, newEvent]);
      }

      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }

      if (action.current === 'cut') {
        let cutEvs = activeCalendar === cutCalendar ? eventsToUpdate : cutCalendar === 'first' ? firstEvents : secondEvents;
        setMoveEvents([...selectedEvents]);
        for (const event of selectedEvents) {
          cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
        }
        if (cutCalendar === 'first') {
          setFirstEvents(cutEvs);
        } else {
          setSecondEvents(cutEvs);
        }

        setTimeout(() => {
          setSnackbarButton({
            action: () => {
              let revertEvs = cutCalendar === 'first' ? firstEvents : secondEvents;
              for (const event of moveEvents) {
                revertEvs = [...revertEvs, event];
              }
              if (cutCalendar === 'first') {
                setFirstEvents(revertEvs);
              } else {
                setSecondEvents(revertEvs);
              }

              let cutEvs = getActiveEvents();
              for (const event of pastedEvents) {
                cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
              }
              if (activeCalendar === 'first') {
                setFirstEvents(cutEvs);
              } else {
                setSecondEvents(cutEvs);
              }
              setToastMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + ' reverted');
              setToastOpen(true);
            },
            text: 'Undo',
          });
          setSnackbarMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + ' pasted');
          setSnackbarOpen(true);
        });
        dummyRef.current!.focus();
      } else {
        setToastMessage('Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' pasted');
        setToastOpen(true);
      }
      if (action.current !== 'copy') {
        setSelectedEvents([]);
      }
    }
  }, [
    action,
    activeCalendar,
    cutCalendar,
    firstEvents,
    getActiveEvents,
    monthDiff,
    moveEvents,
    originDate,
    pastedEvents,
    secondEvents,
    selectedEvents,
    toDate,
  ]);

  const deleteEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    let eventsToUpdate = [...activeEvents];
    action.current = 'delete';
    const activeSelectedEvents = getActiveSelectedEvents();

    if (activeSelectedEvents.length > 0) {
      setDeletedEvents(activeSelectedEvents);

      for (const event of activeSelectedEvents) {
        eventsToUpdate = eventsToUpdate.filter((ev) => ev.id !== event.id);
      }

      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }
      setTimeout(() => {
        setSnackbarButton({
          action: () => {
            for (const event of activeSelectedEvents) {
              eventsToUpdate = [...eventsToUpdate, event];
            }
            if (activeCalendar === 'first') {
              setFirstEvents(eventsToUpdate);
            } else {
              setSecondEvents(eventsToUpdate);
            }
            setDeletedEvents([]);
          },
          text: 'Undo',
        });
        setSnackbarMessage('Event' + (activeSelectedEvents.length === 1 ? '' : 's') + ' deleted');
        setSnackbarOpen(true);
      });
      dummyRef.current!.focus();
    }
  }, [activeCalendar, getActiveEvents, getActiveSelectedEvents]);

  const activateAction = useCallback(
    (type: string) => {
      if (selectedEvents.length > 0) {
        const act = type == 'copy' ? ' copied' : ' cut';
        setOriginDate(toDate);
        setToastMessage('Event' + (selectedEvents.length === 1 ? '' : 's') + act);
        setToastOpen(true);
      }
    },
    [selectedEvents, toDate],
  );

  const copyEvents = useCallback(() => {
    if (activeCalendar === 'first') {
      if (firstSelectedEvents.length > 0) {
        action.current = 'copy';
        setSelectedEvents(firstSelectedEvents);
        activateAction('copy');
      }
    } else {
      if (secondSelectedEvents.length > 0) {
        action.current = 'copy';
        setSelectedEvents(secondSelectedEvents);
        activateAction('copy');
      }
    }
  }, [activateAction, activeCalendar, firstSelectedEvents, secondSelectedEvents]);

  const cutEvents = useCallback(() => {
    if (activeCalendar === 'first') {
      if (firstSelectedEvents.length > 0) {
        action.current = 'cut';
        setSelectedEvents(firstSelectedEvents);
        setCutCalendar(activeCalendar);
        activateAction('cut');
        setDeletedEvents([]);
      }
    } else {
      if (secondSelectedEvents.length > 0) {
        action.current = 'cut';
        setSelectedEvents(secondSelectedEvents);
        setCutCalendar(activeCalendar);
        activateAction('cut');
        setDeletedEvents([]);
      }
    }
  }, [activateAction, activeCalendar, firstSelectedEvents, secondSelectedEvents]);

  const undoEvents = useCallback(() => {
    const activeEvents = getActiveEvents();
    let eventsToUpdate = [...activeEvents];
    if (action.current === 'delete') {
      for (const event of deletedEvents) {
        eventsToUpdate = [...eventsToUpdate, event];
      }
      if (activeCalendar === 'first') {
        setFirstEvents(eventsToUpdate);
      } else {
        setSecondEvents(eventsToUpdate);
      }
      setDeletedEvents([]);
    } else if (action.current === 'cut') {
      let revertEvs = cutCalendar === 'first' ? firstEvents : secondEvents;
      for (const event of moveEvents) {
        revertEvs = [...revertEvs, event];
      }
      if (cutCalendar === 'first') {
        setFirstEvents(revertEvs);
      } else {
        setSecondEvents(revertEvs);
      }

      let cutEvs = getActiveEvents();
      for (const event of pastedEvents) {
        cutEvs = cutEvs.filter((ev) => ev.id !== event.id);
      }
      if (activeCalendar === 'first') {
        setFirstEvents(cutEvs);
      } else {
        setSecondEvents(cutEvs);
      }

      setMoveEvents([]);
      setPastedEvents([]);
    }
  }, [action, activeCalendar, cutCalendar, deletedEvents, firstEvents, getActiveEvents, moveEvents, pastedEvents, secondEvents]);

  const detectAction = useCallback(
    (key: string) => {
      switch (key) {
        case 'delete': // Delete
          deleteEvents();
          break;
        case 'c': // Copy
          copyEvents();
          break;
        case 'x': // Cut
          cutEvents();
          break;
        case 'z': // Undo
          undoEvents();
          break;
        case 'v': // Paste
          pasteEvents();
          break;
        default:
      }
    },
    [copyEvents, cutEvents, deleteEvents, pasteEvents, undoEvents],
  );

  const onFirstSelectedEventsChange = useCallback((args: MbscSelectedEventsChangeEvent) => {
    setFirstSelectedEvents(args.events);
  }, []);

  const onSecondSelectedEventsChange = useCallback((args: MbscSelectedEventsChangeEvent) => {
    setSecondSelectedEvents(args.events);
  }, []);

  const onSelectChange = useCallback(
    (args: MbscSelectChangeEvent) => {
      setSelectValue(args.value);
      detectAction(args.value);
    },
    [detectAction],
  );

  const onSelectClose = useCallback(() => {
    isMenuOpen.current = false;
    setMenuOpen(false);
    // Clear selection
    setSelectValue(null);
  }, []);

  const switchCalendar = useCallback(
    (ev: ChangeEvent<HTMLInputElement>) => {
      setActiveCalendar(ev.target.value);
      if (ev.target.value === 'first') {
        setToDate(firstToDate);
        setSecondSelectedEvents([]);
      } else {
        setToDate(secondToDate);
        setFirstSelectedEvents([]);
      }
    },
    [firstToDate, secondToDate, setFirstSelectedEvents, setSecondSelectedEvents],
  );

  const handleKeyDown = (ev: KeyboardEvent<HTMLDivElement>) => {
    if (ev.ctrlKey || ev.metaKey) {
      detectAction(ev.key);
    }
    if (ev.key === 'Delete') {
      detectAction('delete');
    }
  };

  return (
    <Page>
      <div onKeyDown={handleKeyDown}>
        <div className="mbsc-flex-col md-copy-cut-paste">
          <div className="mbsc-flex-none">
            <SegmentedGroup name="controlled" onChange={switchCalendar}>
              <Segmented value="first" checked={activeCalendar === 'first'}>
                First calendar
              </Segmented>
              <Segmented value="second" checked={activeCalendar === 'second'}>
                Second calendar
              </Segmented>
            </SegmentedGroup>
          </div>
          <div className="mbsc-flex-col mbsc-flex-1-1">
            <div id="demo-copy-cut-paste-first-cont" className="mbsc-flex-1-1 md-copy-cut-paste-cont">
              <Eventcalendar
                className={activeCalendar === 'first' ? '' : 'md-hide-calendar'}
                view={viewSettings}
                clickToCreate={true}
                dragToCreate={true}
                dragToMove={true}
                dragToResize={true}
                selectMultipleEvents={true}
                data={firstEvents}
                selectedEvents={firstSelectedEvents}
                onSelectedEventsChange={onFirstSelectedEventsChange}
                onPageLoading={handlePageLoading}
                onCellRightClick={handleCellRightClick}
                onEventRightClick={handleEventRightClick}
                onEventDeleted={handleEventDeleted}
              />
            </div>
            <div id="demo-copy-cut-paste-second-cont" className="mbsc-flex-1-1 md-copy-cut-paste-cont">
              <Eventcalendar
                className={activeCalendar === 'second' ? '' : 'md-hide-calendar'}
                view={viewSettings}
                clickToCreate={true}
                dragToCreate={true}
                dragToMove={true}
                dragToResize={true}
                selectMultipleEvents={true}
                data={secondEvents}
                selectedEvents={secondSelectedEvents}
                onSelectedEventsChange={onSecondSelectedEventsChange}
                onPageLoading={handlePageLoading}
                onCellRightClick={handleCellRightClick}
                onEventRightClick={handleEventRightClick}
                onEventDeleted={handleEventDeleted}
              />
            </div>
            <Select
              touchUi={false}
              display="anchored"
              anchor={menuAnchor}
              isOpen={menuOpen}
              buttons={[]}
              data={menuData}
              value={selectValue}
              onChange={onSelectChange}
              onClose={onSelectClose}
              inputProps={{ type: 'hidden' }}
            />
          </div>
        </div>
        <div tabIndex={-1} ref={dummyRef}></div>
      </div>
      <Toast isOpen={isToastOpen} message={toastMessage} onClose={handleToastClose} />
      <Snackbar isOpen={isSnackbarOpen} duration={3000} message={snackbarMessage} button={snackbarButton} onClose={handleSnackbarClose} />
    </Page>
  );
};
export default App;
<div id="content"></div>
.md-copy-cut-paste .mbsc-segmented {
  width: 300px;
  margin-left: auto;
  margin-right: auto;
}

.md-copy-cut-paste .md-hide-calendar {
  visibility: hidden;
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}
Move events between two event calendars using cut, copy, paste, and undo — switch calendars.

Calendar - Themes and Dark Mode

Change demo

The look and feel of the event calendar can be deeply customized. There are four levels of customization:

  • Base themes: Choose between iOS, Material and Windows.
  • Light or dark: Every theme has a light and dark variant. Setting the themeVariant to 'auto' will switch based on system settings.
  • Custom themes: Use the theme builder to customize the colors and make it match your brand.
  • Custom CSS: If you need further customization, the sky is the limit with CSS overrides.

You can also see how every example looks by changing the theme from the header.

Calendar - Localization

Change demo

The components are fully localized. In case of the event calendar this covers date and time format, button copy, rtl and more. You can see how each example shows up by clicking on the small flag icon or checking the examples below.

All settings can be manually overridden  See what options the localization impacts →

Calendar - Gregorian, Jalali & Hijri

Change demo

The event calendar supports multiple calendar systems. You can control it with the calendarSystem setting, and it supports the following options:

  • Gregorian - it is included by default
  • Jalali - it is the default system of the Persian calendar and is included within the Farsi language pack
  • Hijri - it is included in the Arabic language pack
Interested in localization?  Explore this example →

Calendar - Event Hooks

Change demo

The event calendar ships with different hooks for deep customization. Events are triggered through the lifecycle of the component where you can tie in custom functionality and code.

While users interact with the UI events like onEventClick, onInit, onSelectedDateChange ... will be triggered.

For a complete list of events go to the documentation  See available lifecycle events →

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Already have an account?
Get started with Mobiscroll for Angular

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for React

Give the components a try locally and see how they look in your project.

Get started with Mobiscroll for Javascript

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for jQuery

Give the components a try in a starter app or see how they look in your project.

Get started with Mobiscroll for Vue

Give the components a try locally and see how they look in your project.

Already have an account?
Simple two minute install guide for jQuery
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folder into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file. Make sure to have jQuery loaded before this.

Copy code <link href="css/mobiscroll.jquery.min.css" rel="stylesheet" />
<script src="js/mobiscroll.jquery.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide for Javascript
Step 1.
Copy resources
Step 2.
Add references
Step 3.
Copy the code
Step 4.
Refresh browser
Copy the downloaded JS and CSS folders into your project

Extract the downloaded zip (download again) and grab the two folders. Make sure to place it where it can be reached from your html file.

Alternatively you can run the example using our demo app.

file-copy-arrows

Or you can just simply try and play with the examples right from the folder you just unpacked. You don't find the downloaded example? Download it again.

Include the mobiscroll CSS and JS resources in your files

Add this script before the closing </head> tag of your file

Copy code <link href="css/mobiscroll.javascript.min.css" rel="stylesheet" />
<script src="js/mobiscroll.javascript.min.js"></script>

Make sure to have the CSS and JS files copied over as explained in Step 1.

Copy the code into your app

Grab the relevant parts and drop them into your JS, HTML and CSS files.

Copy JS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Reload your application in your favorite browser

arrow-browser-reload@2x

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your React project

Run the following command in the root folder of your React project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config react

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your JSX and CSS files.

Copy JSX
Copy TSX
Copy CSS
Take a look at what you've accomplished

Run $ npm start in the root folder of your app

Copy command $ npm start

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Angular project

Run the following command in the root folder of your Angular project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config angular

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Component and Template files. For quick testing copy the css to into your project's style.css or style.scss.

Copy TS
Copy HTML
Copy CSS
Take a look at what you've accomplished

Run $ ng serve in the root folder of your app

Copy command $ ng serve

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Simple two minute install guide
Step 1.
Install the CLI
Step 2.
Install Mobiscroll
Step 3.
Copy the code
Step 4.
Run the app
Install the Mobiscroll CLI from npm

You will be able to configure Mobiscroll with ease in your app with the CLI

Copy command $ npm install -g @mobiscroll/cli
Install Mobiscroll in your Vue project

Run the following command in the root folder of your Vue project.

Don't have a project? Try it with our demo app.

Copy command $ mobiscroll config vue

You will be prompted to log in with your mobiscroll account. Set your password here.

Working behind a proxy?

If you're working behind a proxy server, additional configuration might be needed. Please check the proxy configuration options in the documentation.

Using a CI/CD workflow?

The package will be installed from a private npm registry, which requires authentication. If your project uses a CI/CD workflow, read this guide on how to make it work.

Copy the code into your app

Grab the relevant parts and drop them into your Vue page.

Copy
Copy
Take a look at what you've accomplished

Run $ npm run dev in the root folder of your app

Copy command $ npm run dev

And voilà, everything should be running smoothly.

If something is not running correctly or if there is trouble

Check out these common errors and solutions or reach out and let us help you.

Keep things running smoothly

We have sent an email with verification instructions to you. Please make sure to follow the steps and verify it's you.

In case you fail to verify the account, the trial will be interrupted.

If you have any trouble

Don't hesitate to let us know.

install-help-bck
Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Demos
Theme Select
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos